#include <stdio.h>
#include <stdlib.h>
typedef unsigned int Atom;
#define isPTR(a)   (((a)&3) == 0)
#define isCTR(a)   (((a)&3) == 1)
#define isINT(a)   (((a)&3) == 2)
#define isFUN(a)   (((a)&3) == 3)
#define getPTR(a)  ((Atom*) (a))
#define getCTR(a)  ((a) >> 2)
#define getINT(a)  ((int) (((int) (a)) >> 2))
#define getFUN(a)  ((void*) (((unsigned int) (a)) & (~3)))
#define makePTR(x) ((Atom) (x))
#define makeCTR(x) ((Atom) (((x) << 2) | 1))
#define makeINT(x) ((Atom) ((((unsigned int) (x)) << 2) | 2))
#define makeFUN(x) ((Atom) (((unsigned int) (x)) | 3))
#define HEAP_SIZE 22000
#define STACK_SIZE 3000
typedef struct {
  Atom* current;
  void* returnAddress;
} Frame;
#define L_POP(n) L_sp-=n; L_top = L_sp[-1];
#define L_PUSH(a) L_top = a; L_sp[0] = L_top; L_sp++;
#define R_POP \
  R_sp++;\
  R_top_returnAddress = R_sp[1].returnAddress;\
  R_top_current = R_sp[1].current;
#define R_PUSH(ra, cur) \
  R_top_returnAddress = R_sp[0].returnAddress = ra; \
  R_top_current = R_sp[0].current = cur; \
  R_sp--;
#define makeHDR(x)        ((x) << 1)
#define VISITED           1
#define size(x)           ((x) >> 1)
#define C_False 0
#define C_True 1
#define C_Branch 0
#define C_Empty 1
#define C_Cons 0
#define C_Nil 1


int main() {
register Atom* L_sp;
Atom* L_base;
register Atom L_top;
register Frame* R_sp;
Frame* R_base;
register void* R_top_returnAddress;
register Atom* R_top_current;
register Atom* hp;
register Atom* heapEnd;
register Atom atom;
register Atom* app;
register int res;
Atom* fromSpace;
Atom* toSpace;
Atom* fromSpaceEnd;
Atom* toSpaceEnd;
Atom* scan;
Atom* free;
Atom* p;
Atom* from;
Frame* frame;
void* gc_copy_ret;
void* gc_ret;
void* eval_ret_addr;
int i;
int j;
int n;
int m;
L_base = L_sp = malloc(sizeof(Atom) * STACK_SIZE);
R_base = R_sp = (Frame*) &L_sp[STACK_SIZE-1];
fromSpace = hp = malloc(sizeof(Atom) * HEAP_SIZE);
heapEnd = fromSpaceEnd = &fromSpace[HEAP_SIZE-1000];
toSpace = malloc(sizeof(Atom) * HEAP_SIZE);
toSpaceEnd = &toSpace[HEAP_SIZE-1000];
print("S");
atom = makePTR(hp);
*hp++ = makeHDR(1); *hp++ =  makeFUN(&&F_main);
L_PUSH(atom);
eval_ret_addr = &&LABEL_121;
goto EVAL;
LABEL_121:
putnum(getINT(L_top));
return 0;
EVAL:
if (isPTR(atom)) {
  app = getPTR(atom);
  EVAL_APP:
  if (isFUN(app[1])) {
    L_PUSH(makePTR(app));
    R_PUSH(eval_ret_addr, app);
    goto *getFUN(app[1]);
    EVAL_RET:
    if (R_top_current) {
      R_top_current[0] = makeHDR(1);
      R_top_current[1] = L_top;
    }
    eval_ret_addr = R_top_returnAddress;
    R_POP;
    goto *eval_ret_addr;
  }
  else if (isCTR(app[1])) {
    L_PUSH(makePTR(app)); res = getCTR(app[1]);
    goto *eval_ret_addr;
  }
  else if (isPTR(app[1])) {
    app = getPTR(app[1]);
    goto EVAL_APP;
  }
  else {
    L_PUSH(app[1]); res = getINT(app[1]);
    goto *eval_ret_addr;
  }
} else {
  L_PUSH(atom);
  res = getINT(atom);
  goto *eval_ret_addr;
}
TAIL_EVAL:
if (isPTR(atom)) {
  app = getPTR(atom);
  TAIL_EVAL_APP:
  if (isFUN(app[1])) {
    L_PUSH(makePTR(app));
    if (R_top_current) {
      R_top_current[0] = makeHDR(1);
      R_top_current[1] = makePTR(app);
    }
    R_top_current = R_sp[1].current = app;
    goto *getFUN(app[1]);
  }
  else if (isPTR(app[1])) {
    app = getPTR(app[1]);
    goto TAIL_EVAL_APP;
  }
  else if (isINT(app[1])) {
    L_PUSH(app[1]); res = getINT(app[1]);
    goto EVAL_RET;
  }
  else {
    L_PUSH(makePTR(app)); res = getCTR(app[1]);
    goto EVAL_RET;
  }
} else {
  L_PUSH(atom);
  res = getINT(atom);
  goto EVAL_RET;
}
F_main:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_122;
  goto GC_COLLECT;
}
  GC_RET_122:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_fromTo);
hp[2] = makeINT(0);
hp[3] = makeINT(255);
hp[4] = makeHDR(3);
hp[5] = makeFUN(&&F_replicate);
hp[6] = makeINT(6000);
hp[7] = makePTR(hp+0);
hp[8] = makeHDR(3);
hp[9] = makeFUN(&&F_all);
hp[10] = makeFUN(&&F_prop);
hp[11] = makePTR(hp+4);
hp[12] = makeHDR(2);
hp[13] = makeFUN(&&F_int);
hp[14] = makePTR(hp+8);
atom = makePTR(hp+12);
hp += 15;
L_POP(1);
L_PUSH(atom);
goto F_int;
F_insert:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_126;
  goto GC_COLLECT;
}
  GC_RET_126:
atom = getPTR(L_sp[-1])[3];
eval_ret_addr = &&LABEL_127;
goto EVAL;
LABEL_127:
switch (res) {
case C_Empty:
hp[0] = makeHDR(4);
hp[1] = makeCTR(C_Branch);
hp[2] = getPTR(L_sp[-2])[2];
hp[3] = makeCTR(C_Empty);
hp[4] = makeCTR(C_Empty);
atom = makePTR(hp+0);
hp += 5;
L_POP(2);
L_PUSH(atom);
res = C_Branch;
goto EVAL_RET;
case C_Branch:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_insert);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = getPTR(L_sp[-1])[4];
hp[4] = makeHDR(4);
hp[5] = makeCTR(C_Branch);
hp[6] = getPTR(L_sp[-2])[2];
hp[7] = makePTR(hp+0);
hp[8] = getPTR(L_sp[-1])[3];
atom = makePTR(hp+4);
hp += 9;
L_POP(2);
L_PUSH(atom);
res = C_Branch;
goto EVAL_RET;
}
F_and:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_129;
  goto GC_COLLECT;
}
  GC_RET_129:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_130;
goto EVAL;
LABEL_130:
switch (res) {
case C_False:
L_POP(2);
L_PUSH(makeCTR(C_False));
res = C_False;
goto EVAL_RET;
case C_True:
atom = getPTR(L_sp[-2])[3];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_size:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_131;
  goto GC_COLLECT;
}
  GC_RET_131:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_132;
goto EVAL;
LABEL_132:
switch (res) {
case C_Empty:
L_POP(2);
L_PUSH(makeINT(0));
res = 0;
goto EVAL_RET;
case C_Branch:
L_PUSH(makeINT(1));
res = 1;
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_size);
hp[2] = getPTR(L_sp[-2])[3];
atom = makePTR(hp+0);
hp += 3;
eval_ret_addr = &&LABEL_133;
goto EVAL;
LABEL_133:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_size);
hp[2] = getPTR(L_sp[-3])[4];
atom = makePTR(hp+0);
hp += 3;
eval_ret_addr = &&LABEL_134;
goto EVAL;
LABEL_134:
L_POP(1);
res = getINT(L_top) + res;
L_POP(1);
L_PUSH(makeINT(res));
L_POP(1);
res = getINT(L_top) + res;
L_POP(3);
L_PUSH(makeINT(res));
goto EVAL_RET;
}
F_fromList:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_135;
  goto GC_COLLECT;
}
  GC_RET_135:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_136;
goto EVAL;
LABEL_136:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_Empty));
res = C_Empty;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_fromList);
hp[2] = getPTR(L_sp[-1])[3];
hp[3] = makeHDR(3);
hp[4] = makeFUN(&&F_insert);
hp[5] = getPTR(L_sp[-1])[2];
hp[6] = makePTR(hp+0);
atom = makePTR(hp+3);
hp += 7;
L_POP(2);
L_PUSH(atom);
goto F_insert;
}
F_toList:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_138;
  goto GC_COLLECT;
}
  GC_RET_138:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_139;
goto EVAL;
LABEL_139:
switch (res) {
case C_Empty:
L_POP(2);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
case C_Branch:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_toList);
hp[2] = getPTR(L_sp[-1])[3];
hp[3] = makeHDR(2);
hp[4] = makeFUN(&&F_toList);
hp[5] = getPTR(L_sp[-1])[4];
hp[6] = makeHDR(3);
hp[7] = makeFUN(&&F_ilv);
hp[8] = makePTR(hp+0);
hp[9] = makePTR(hp+3);
hp[10] = makeHDR(3);
hp[11] = makeCTR(C_Cons);
hp[12] = getPTR(L_sp[-1])[2];
hp[13] = makePTR(hp+6);
atom = makePTR(hp+10);
hp += 14;
L_POP(2);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
}
F_ilv:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_143;
  goto GC_COLLECT;
}
  GC_RET_143:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_144;
goto EVAL;
LABEL_144:
switch (res) {
case C_Nil:
atom = getPTR(L_sp[-2])[3];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
case C_Cons:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_145;
goto EVAL;
LABEL_145:
switch (res) {
case C_Nil:
hp[0] = makeHDR(3);
hp[1] = makeCTR(C_Cons);
hp[2] = getPTR(L_sp[-2])[2];
hp[3] = getPTR(L_sp[-2])[3];
atom = makePTR(hp+0);
hp += 4;
L_POP(3);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_ilv);
hp[2] = getPTR(L_sp[-2])[3];
hp[3] = getPTR(L_sp[-1])[3];
hp[4] = makeHDR(3);
hp[5] = makeCTR(C_Cons);
hp[6] = getPTR(L_sp[-1])[2];
hp[7] = makePTR(hp+0);
hp[8] = makeHDR(3);
hp[9] = makeCTR(C_Cons);
hp[10] = getPTR(L_sp[-2])[2];
hp[11] = makePTR(hp+4);
atom = makePTR(hp+8);
hp += 12;
L_POP(3);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
}
}
F_replicate:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_148;
  goto GC_COLLECT;
}
  GC_RET_148:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_149;
goto EVAL;
LABEL_149:
L_PUSH(makeINT(0));
res = 0;
L_POP(1);
res = getINT(L_top) == res ? C_True : C_False;
L_POP(1);
L_PUSH(makeCTR(res));
switch (res) {
case C_True:
L_POP(2);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
case C_False:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&P_SUB);
hp[2] = getPTR(L_sp[-2])[2];
hp[3] = makeINT(1);
hp[4] = makeHDR(3);
hp[5] = makeFUN(&&F_replicate);
hp[6] = makePTR(hp+0);
hp[7] = getPTR(L_sp[-2])[3];
hp[8] = makeHDR(3);
hp[9] = makeCTR(C_Cons);
hp[10] = getPTR(L_sp[-2])[3];
hp[11] = makePTR(hp+4);
atom = makePTR(hp+8);
hp += 12;
L_POP(2);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
}
F_fromTo:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_152;
  goto GC_COLLECT;
}
  GC_RET_152:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_153;
goto EVAL;
LABEL_153:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_154;
goto EVAL;
LABEL_154:
L_POP(1);
res = getINT(L_top) <= res ? C_True : C_False;
L_POP(1);
L_PUSH(makeCTR(res));
switch (res) {
case C_True:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&P_ADD);
hp[2] = getPTR(L_sp[-2])[2];
hp[3] = makeINT(1);
hp[4] = makeHDR(3);
hp[5] = makeFUN(&&F_fromTo);
hp[6] = makePTR(hp+0);
hp[7] = getPTR(L_sp[-2])[3];
hp[8] = makeHDR(3);
hp[9] = makeCTR(C_Cons);
hp[10] = getPTR(L_sp[-2])[2];
hp[11] = makePTR(hp+4);
atom = makePTR(hp+8);
hp += 12;
L_POP(2);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
case C_False:
L_POP(2);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
}
F_repeat:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_157;
  goto GC_COLLECT;
}
  GC_RET_157:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_repeat);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = makeHDR(3);
hp[4] = makeCTR(C_Cons);
hp[5] = getPTR(L_sp[-1])[2];
hp[6] = makePTR(hp+0);
atom = makePTR(hp+3);
hp += 7;
L_POP(1);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
F_equal:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_159;
  goto GC_COLLECT;
}
  GC_RET_159:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_160;
goto EVAL;
LABEL_160:
switch (res) {
case C_Nil:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_161;
goto EVAL;
LABEL_161:
switch (res) {
case C_Nil:
L_POP(3);
L_PUSH(makeCTR(C_True));
res = C_True;
goto EVAL_RET;
case C_Cons:
L_POP(3);
L_PUSH(makeCTR(C_False));
res = C_False;
goto EVAL_RET;
}
case C_Cons:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_162;
goto EVAL;
LABEL_162:
switch (res) {
case C_Nil:
L_POP(3);
L_PUSH(makeCTR(C_False));
res = C_False;
goto EVAL_RET;
case C_Cons:
atom = getPTR(L_sp[-2])[2];
eval_ret_addr = &&LABEL_163;
goto EVAL;
LABEL_163:
atom = getPTR(L_sp[-2])[2];
eval_ret_addr = &&LABEL_164;
goto EVAL;
LABEL_164:
L_POP(1);
res = getINT(L_top) == res ? C_True : C_False;
L_POP(1);
L_PUSH(makeCTR(res));
switch (res) {
case C_False:
L_POP(4);
L_PUSH(makeCTR(C_False));
res = C_False;
goto EVAL_RET;
case C_True:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_equal);
hp[2] = getPTR(L_sp[-3])[3];
hp[3] = getPTR(L_sp[-2])[3];
atom = makePTR(hp+0);
hp += 4;
L_POP(4);
L_PUSH(atom);
goto F_equal;
}
}
}
F_prop:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_165;
  goto GC_COLLECT;
}
  GC_RET_165:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_fromList);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = makeHDR(2);
hp[4] = makeFUN(&&F_toList);
hp[5] = makePTR(hp+0);
hp[6] = makeHDR(3);
hp[7] = makeFUN(&&F_equal);
hp[8] = getPTR(L_sp[-1])[2];
hp[9] = makePTR(hp+3);
atom = makePTR(hp+6);
hp += 10;
L_POP(1);
L_PUSH(atom);
goto F_equal;
F_all:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_168;
  goto GC_COLLECT;
}
  GC_RET_168:
atom = getPTR(L_sp[-1])[3];
eval_ret_addr = &&LABEL_169;
goto EVAL;
LABEL_169:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_True));
res = C_True;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(2);
hp[1] = getPTR(L_sp[-2])[2];
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = makeHDR(3);
hp[4] = makeFUN(&&F_all);
hp[5] = getPTR(L_sp[-2])[2];
hp[6] = getPTR(L_sp[-1])[3];
hp[7] = makeHDR(3);
hp[8] = makeFUN(&&F_and);
hp[9] = makePTR(hp+0);
hp[10] = makePTR(hp+3);
atom = makePTR(hp+7);
hp += 11;
L_POP(2);
L_PUSH(atom);
goto F_and;
}
F_int:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_172;
  goto GC_COLLECT;
}
  GC_RET_172:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_173;
goto EVAL;
LABEL_173:
switch (res) {
case C_True:
L_POP(2);
L_PUSH(makeINT(1));
res = 1;
goto EVAL_RET;
case C_False:
L_POP(2);
L_PUSH(makeINT(0));
res = 0;
goto EVAL_RET;
}
P_ADD:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_174;
  goto GC_COLLECT;
}
  GC_RET_174:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_175;
goto EVAL;
LABEL_175:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_176;
goto EVAL;
LABEL_176:
L_POP(1);
res = getINT(L_top) + res;
L_POP(2);
L_PUSH(makeINT(res));
goto EVAL_RET;
P_SUB:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_177;
  goto GC_COLLECT;
}
  GC_RET_177:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_178;
goto EVAL;
LABEL_178:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_179;
goto EVAL;
LABEL_179:
L_POP(1);
res = getINT(L_top) - res;
L_POP(2);
L_PUSH(makeINT(res));
goto EVAL_RET;
P_EQ:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_180;
  goto GC_COLLECT;
}
  GC_RET_180:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_181;
goto EVAL;
LABEL_181:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_182;
goto EVAL;
LABEL_182:
L_POP(1);
res = getINT(L_top) == res ? C_True : C_False;
L_POP(2);
L_PUSH(makeCTR(res));
goto EVAL_RET;
P_NEQ:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_183;
  goto GC_COLLECT;
}
  GC_RET_183:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_184;
goto EVAL;
LABEL_184:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_185;
goto EVAL;
LABEL_185:
L_POP(1);
res = getINT(L_top) != res ? C_True : C_False;
L_POP(2);
L_PUSH(makeCTR(res));
goto EVAL_RET;
P_LEQ:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_186;
  goto GC_COLLECT;
}
  GC_RET_186:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_187;
goto EVAL;
LABEL_187:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_188;
goto EVAL;
LABEL_188:
L_POP(1);
res = getINT(L_top) <= res ? C_True : C_False;
L_POP(2);
L_PUSH(makeCTR(res));
goto EVAL_RET;
GC_COPY:
if (from[0] == VISITED) {
  atom = from[1];
  goto *gc_copy_ret;
}
if (isPTR(from[1])) { from = getPTR(from[1]); goto GC_COPY; }
if (size(from[0]) == 1) { atom = from[1]; }
else {
  n = size(from[0]) + 1;
  //printf("Copy (%i);\n", n-1);
  atom = makePTR(free);
  for (i = 0; i < n; i++)
    { *free = from[i]; free++; }
  from[0] = VISITED;
  from[1] = atom;
}
goto *gc_copy_ret;
GC_COLLECT:
//printf("GC invoked (%i);\n", hp - fromSpace);
scan = toSpace;
free = toSpace;
for (p = L_base; p < L_sp; p++) {
  if (isPTR(*p)) {
    from = getPTR(*p);
    gc_copy_ret = &&GC_COPY_RET1; goto GC_COPY; GC_COPY_RET1:
    *p = atom;
  }
}
while (scan < free) {
  m = size(*scan); scan++;
  //printf("Scan (%i);\n", m);
  for (j = 0; j < m; j++) {
    if (isPTR(*scan)) {
      from = getPTR(*scan);
      gc_copy_ret = &&GC_COPY_RET2; goto GC_COPY; GC_COPY_RET2:
      *scan = atom;
    }
    scan++;
  }
}
for (frame = R_base; frame > R_sp; frame--) {
  p = frame->current;
  frame->current = 0;
  while (p && p[0] != VISITED && isPTR(p[1])) p = getPTR(p[1]);
  if (p && p[0] == VISITED) {
    if (isPTR(p[1])) frame->current = getPTR(p[1]);
  }
}
hp = free;
p = fromSpace; fromSpace = toSpace; toSpace = p;
p = fromSpaceEnd; fromSpaceEnd = toSpaceEnd; toSpaceEnd = p;
heapEnd = fromSpaceEnd;
L_top = L_sp[-1];
R_top_returnAddress = R_sp[1].returnAddress;
R_top_current = R_sp[1].current;
//printf("GC finished (%i);\n", hp - fromSpace);
goto *gc_ret;
}



