#include <stdio.h>
#include <stdlib.h>
typedef unsigned int Atom;
#define isPTR(a)   (((a)&3) == 0)
#define isCTR(a)   (((a)&3) == 1)
#define isINT(a)   (((a)&3) == 2)
#define isFUN(a)   (((a)&3) == 3)
#define getPTR(a)  ((Atom*) (a))
#define getCTR(a)  ((a) >> 2)
#define getINT(a)  ((int) (((int) (a)) >> 2))
#define getFUN(a)  ((void*) (((unsigned int) (a)) & (~3)))
#define makePTR(x) ((Atom) (x))
#define makeCTR(x) ((Atom) (((x) << 2) | 1))
#define makeINT(x) ((Atom) ((((unsigned int) (x)) << 2) | 2))
#define makeFUN(x) ((Atom) (((unsigned int) (x)) | 3))
#define HEAP_SIZE 22000
#define STACK_SIZE 3000
typedef struct {
  Atom* current;
  void* returnAddress;
} Frame;
#define L_POP(n) L_sp-=n; L_top = L_sp[-1];
#define L_PUSH(a) L_top = a; L_sp[0] = L_top; L_sp++;
#define R_POP \
  R_sp++;\
  R_top_returnAddress = R_sp[1].returnAddress;\
  R_top_current = R_sp[1].current;
#define R_PUSH(ra, cur) \
  R_top_returnAddress = R_sp[0].returnAddress = ra; \
  R_top_current = R_sp[0].current = cur; \
  R_sp--;
#define makeHDR(x)        ((x) << 1)
#define VISITED           1
#define size(x)           ((x) >> 1)
#define C_False 0
#define C_True 1
#define C_Just 0
#define C_Nothing 1
#define C_Cons 0
#define C_Nil 1
#define C_Hash 0
#define C_K 0
#define C_Pair 0
#define C_H 0


int main() {
register Atom* L_sp;
Atom* L_base;
register Atom L_top;
register Frame* R_sp;
Frame* R_base;
register void* R_top_returnAddress;
register Atom* R_top_current;
register Atom* hp;
register Atom* heapEnd;
register Atom atom;
register Atom* app;
register int res;
Atom* fromSpace;
Atom* toSpace;
Atom* fromSpaceEnd;
Atom* toSpaceEnd;
Atom* scan;
Atom* free;
Atom* p;
Atom* from;
Frame* frame;
void* gc_copy_ret;
void* gc_ret;
void* eval_ret_addr;
int i;
int j;
int n;
int m;
L_base = L_sp = malloc(sizeof(Atom) * STACK_SIZE);
R_base = R_sp = (Frame*) &L_sp[STACK_SIZE-1];
fromSpace = hp = malloc(sizeof(Atom) * HEAP_SIZE);
heapEnd = fromSpaceEnd = &fromSpace[HEAP_SIZE-1000];
toSpace = malloc(sizeof(Atom) * HEAP_SIZE);
toSpaceEnd = &toSpace[HEAP_SIZE-1000];
print("S");
atom = makePTR(hp);
*hp++ = makeHDR(1); *hp++ =  makeFUN(&&F_main);
L_PUSH(atom);
eval_ret_addr = &&LABEL_692;
goto EVAL;
LABEL_692:
putnum(getINT(L_top));
return 0;
EVAL:
if (isPTR(atom)) {
  app = getPTR(atom);
  EVAL_APP:
  if (isFUN(app[1])) {
    L_PUSH(makePTR(app));
    R_PUSH(eval_ret_addr, app);
    goto *getFUN(app[1]);
    EVAL_RET:
    if (R_top_current) {
      R_top_current[0] = makeHDR(1);
      R_top_current[1] = L_top;
    }
    eval_ret_addr = R_top_returnAddress;
    R_POP;
    goto *eval_ret_addr;
  }
  else if (isCTR(app[1])) {
    L_PUSH(makePTR(app)); res = getCTR(app[1]);
    goto *eval_ret_addr;
  }
  else if (isPTR(app[1])) {
    app = getPTR(app[1]);
    goto EVAL_APP;
  }
  else {
    L_PUSH(app[1]); res = getINT(app[1]);
    goto *eval_ret_addr;
  }
} else {
  L_PUSH(atom);
  res = getINT(atom);
  goto *eval_ret_addr;
}
TAIL_EVAL:
if (isPTR(atom)) {
  app = getPTR(atom);
  TAIL_EVAL_APP:
  if (isFUN(app[1])) {
    L_PUSH(makePTR(app));
    if (R_top_current) {
      R_top_current[0] = makeHDR(1);
      R_top_current[1] = makePTR(app);
    }
    R_top_current = R_sp[1].current = app;
    goto *getFUN(app[1]);
  }
  else if (isPTR(app[1])) {
    app = getPTR(app[1]);
    goto TAIL_EVAL_APP;
  }
  else if (isINT(app[1])) {
    L_PUSH(app[1]); res = getINT(app[1]);
    goto EVAL_RET;
  }
  else {
    L_PUSH(makePTR(app)); res = getCTR(app[1]);
    goto EVAL_RET;
  }
} else {
  L_PUSH(atom);
  res = getINT(atom);
  goto EVAL_RET;
}
F_main:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_693;
  goto GC_COLLECT;
}
  GC_RET_693:
hp[0] = makeHDR(3);
hp[1] = makeCTR(C_Cons);
hp[2] = makeINT(115);
hp[3] = makeCTR(C_Nil);
hp[4] = makeHDR(3);
hp[5] = makeCTR(C_Cons);
hp[6] = makeINT(97);
hp[7] = makePTR(hp+0);
hp[8] = makeHDR(3);
hp[9] = makeCTR(C_Cons);
hp[10] = makeINT(101);
hp[11] = makeCTR(C_Nil);
hp[12] = makeHDR(3);
hp[13] = makeCTR(C_Cons);
hp[14] = makeINT(115);
hp[15] = makePTR(hp+8);
hp[16] = makeHDR(3);
hp[17] = makeCTR(C_Cons);
hp[18] = makeINT(97);
hp[19] = makePTR(hp+12);
hp[20] = makeHDR(3);
hp[21] = makeCTR(C_Cons);
hp[22] = makeINT(99);
hp[23] = makePTR(hp+16);
hp[24] = makeHDR(3);
hp[25] = makeCTR(C_Cons);
hp[26] = makeINT(115);
hp[27] = makeCTR(C_Nil);
hp[28] = makeHDR(3);
hp[29] = makeCTR(C_Cons);
hp[30] = makeINT(115);
hp[31] = makePTR(hp+24);
hp[32] = makeHDR(3);
hp[33] = makeCTR(C_Cons);
hp[34] = makeINT(97);
hp[35] = makePTR(hp+28);
hp[36] = makeHDR(3);
hp[37] = makeCTR(C_Cons);
hp[38] = makeINT(108);
hp[39] = makePTR(hp+32);
hp[40] = makeHDR(3);
hp[41] = makeCTR(C_Cons);
hp[42] = makeINT(99);
hp[43] = makePTR(hp+36);
hp[44] = makeHDR(3);
hp[45] = makeCTR(C_Cons);
hp[46] = makeINT(97);
hp[47] = makeCTR(C_Nil);
hp[48] = makeHDR(3);
hp[49] = makeCTR(C_Cons);
hp[50] = makeINT(116);
hp[51] = makePTR(hp+44);
hp[52] = makeHDR(3);
hp[53] = makeCTR(C_Cons);
hp[54] = makeINT(97);
hp[55] = makePTR(hp+48);
hp[56] = makeHDR(3);
hp[57] = makeCTR(C_Cons);
hp[58] = makeINT(100);
hp[59] = makePTR(hp+52);
hp[60] = makeHDR(3);
hp[61] = makeCTR(C_Cons);
hp[62] = makeINT(116);
hp[63] = makeCTR(C_Nil);
hp[64] = makeHDR(3);
hp[65] = makeCTR(C_Cons);
hp[66] = makeINT(108);
hp[67] = makePTR(hp+60);
hp[68] = makeHDR(3);
hp[69] = makeCTR(C_Cons);
hp[70] = makeINT(117);
hp[71] = makePTR(hp+64);
hp[72] = makeHDR(3);
hp[73] = makeCTR(C_Cons);
hp[74] = makeINT(97);
hp[75] = makePTR(hp+68);
hp[76] = makeHDR(3);
hp[77] = makeCTR(C_Cons);
hp[78] = makeINT(102);
hp[79] = makePTR(hp+72);
hp[80] = makeHDR(3);
hp[81] = makeCTR(C_Cons);
hp[82] = makeINT(101);
hp[83] = makePTR(hp+76);
hp[84] = makeHDR(3);
hp[85] = makeCTR(C_Cons);
hp[86] = makeINT(100);
hp[87] = makePTR(hp+80);
hp[88] = makeHDR(3);
hp[89] = makeCTR(C_Cons);
hp[90] = makeINT(103);
hp[91] = makeCTR(C_Nil);
hp[92] = makeHDR(3);
hp[93] = makeCTR(C_Cons);
hp[94] = makeINT(110);
hp[95] = makePTR(hp+88);
hp[96] = makeHDR(3);
hp[97] = makeCTR(C_Cons);
hp[98] = makeINT(105);
hp[99] = makePTR(hp+92);
hp[100] = makeHDR(3);
hp[101] = makeCTR(C_Cons);
hp[102] = makeINT(118);
hp[103] = makePTR(hp+96);
hp[104] = makeHDR(3);
hp[105] = makeCTR(C_Cons);
hp[106] = makeINT(105);
hp[107] = makePTR(hp+100);
hp[108] = makeHDR(3);
hp[109] = makeCTR(C_Cons);
hp[110] = makeINT(114);
hp[111] = makePTR(hp+104);
hp[112] = makeHDR(3);
hp[113] = makeCTR(C_Cons);
hp[114] = makeINT(101);
hp[115] = makePTR(hp+108);
hp[116] = makeHDR(3);
hp[117] = makeCTR(C_Cons);
hp[118] = makeINT(100);
hp[119] = makePTR(hp+112);
hp[120] = makeHDR(3);
hp[121] = makeCTR(C_Cons);
hp[122] = makeINT(111);
hp[123] = makeCTR(C_Nil);
hp[124] = makeHDR(3);
hp[125] = makeCTR(C_Cons);
hp[126] = makeINT(100);
hp[127] = makePTR(hp+120);
hp[128] = makeHDR(3);
hp[129] = makeCTR(C_Cons);
hp[130] = makeINT(101);
hp[131] = makeCTR(C_Nil);
hp[132] = makeHDR(3);
hp[133] = makeCTR(C_Cons);
hp[134] = makeINT(115);
hp[135] = makePTR(hp+128);
hp[136] = makeHDR(3);
hp[137] = makeCTR(C_Cons);
hp[138] = makeINT(108);
hp[139] = makePTR(hp+132);
hp[140] = makeHDR(3);
hp[141] = makeCTR(C_Cons);
hp[142] = makeINT(101);
hp[143] = makePTR(hp+136);
hp[144] = makeHDR(3);
hp[145] = makeCTR(C_Cons);
hp[146] = makeINT(103);
hp[147] = makeCTR(C_Nil);
hp[148] = makeHDR(3);
hp[149] = makeCTR(C_Cons);
hp[150] = makeINT(110);
hp[151] = makePTR(hp+144);
hp[152] = makeHDR(3);
hp[153] = makeCTR(C_Cons);
hp[154] = makeINT(105);
hp[155] = makePTR(hp+148);
hp[156] = makeHDR(3);
hp[157] = makeCTR(C_Cons);
hp[158] = makeINT(100);
hp[159] = makePTR(hp+152);
hp[160] = makeHDR(3);
hp[161] = makeCTR(C_Cons);
hp[162] = makeINT(105);
hp[163] = makePTR(hp+156);
hp[164] = makeHDR(3);
hp[165] = makeCTR(C_Cons);
hp[166] = makeINT(104);
hp[167] = makePTR(hp+160);
hp[168] = makeHDR(3);
hp[169] = makeCTR(C_Cons);
hp[170] = makeINT(102);
hp[171] = makeCTR(C_Nil);
hp[172] = makeHDR(3);
hp[173] = makeCTR(C_Cons);
hp[174] = makeINT(105);
hp[175] = makePTR(hp+168);
hp[176] = makeHDR(3);
hp[177] = makeCTR(C_Cons);
hp[178] = makeINT(116);
hp[179] = makeCTR(C_Nil);
hp[180] = makeHDR(3);
hp[181] = makeCTR(C_Cons);
hp[182] = makeINT(114);
hp[183] = makePTR(hp+176);
hp[184] = makeHDR(3);
hp[185] = makeCTR(C_Cons);
hp[186] = makeINT(111);
hp[187] = makePTR(hp+180);
hp[188] = makeHDR(3);
hp[189] = makeCTR(C_Cons);
hp[190] = makeINT(112);
hp[191] = makePTR(hp+184);
hp[192] = makeHDR(3);
hp[193] = makeCTR(C_Cons);
hp[194] = makeINT(109);
hp[195] = makePTR(hp+188);
hp[196] = makeHDR(3);
hp[197] = makeCTR(C_Cons);
hp[198] = makeINT(105);
hp[199] = makePTR(hp+192);
hp[200] = makeHDR(3);
hp[201] = makeCTR(C_Cons);
hp[202] = makeINT(110);
hp[203] = makeCTR(C_Nil);
hp[204] = makeHDR(3);
hp[205] = makeCTR(C_Cons);
hp[206] = makeINT(105);
hp[207] = makePTR(hp+200);
hp[208] = makeHDR(3);
hp[209] = makeCTR(C_Cons);
hp[210] = makeINT(120);
hp[211] = makeCTR(C_Nil);
hp[212] = makeHDR(3);
hp[213] = makeCTR(C_Cons);
hp[214] = makeINT(105);
hp[215] = makePTR(hp+208);
hp[216] = makeHDR(3);
hp[217] = makeCTR(C_Cons);
hp[218] = makeINT(102);
hp[219] = makePTR(hp+212);
hp[220] = makeHDR(3);
hp[221] = makeCTR(C_Cons);
hp[222] = makeINT(110);
hp[223] = makePTR(hp+216);
hp[224] = makeHDR(3);
hp[225] = makeCTR(C_Cons);
hp[226] = makeINT(105);
hp[227] = makePTR(hp+220);
hp[228] = makeHDR(3);
hp[229] = makeCTR(C_Cons);
hp[230] = makeINT(108);
hp[231] = makeCTR(C_Nil);
hp[232] = makeHDR(3);
hp[233] = makeCTR(C_Cons);
hp[234] = makeINT(120);
hp[235] = makePTR(hp+228);
hp[236] = makeHDR(3);
hp[237] = makeCTR(C_Cons);
hp[238] = makeINT(105);
hp[239] = makePTR(hp+232);
hp[240] = makeHDR(3);
hp[241] = makeCTR(C_Cons);
hp[242] = makeINT(102);
hp[243] = makePTR(hp+236);
hp[244] = makeHDR(3);
hp[245] = makeCTR(C_Cons);
hp[246] = makeINT(110);
hp[247] = makePTR(hp+240);
hp[248] = makeHDR(3);
hp[249] = makeCTR(C_Cons);
hp[250] = makeINT(105);
hp[251] = makePTR(hp+244);
hp[252] = makeHDR(3);
hp[253] = makeCTR(C_Cons);
hp[254] = makeINT(114);
hp[255] = makeCTR(C_Nil);
hp[256] = makeHDR(3);
hp[257] = makeCTR(C_Cons);
hp[258] = makeINT(120);
hp[259] = makePTR(hp+252);
hp[260] = makeHDR(3);
hp[261] = makeCTR(C_Cons);
hp[262] = makeINT(105);
hp[263] = makePTR(hp+256);
hp[264] = makeHDR(3);
hp[265] = makeCTR(C_Cons);
hp[266] = makeINT(102);
hp[267] = makePTR(hp+260);
hp[268] = makeHDR(3);
hp[269] = makeCTR(C_Cons);
hp[270] = makeINT(110);
hp[271] = makePTR(hp+264);
hp[272] = makeHDR(3);
hp[273] = makeCTR(C_Cons);
hp[274] = makeINT(105);
hp[275] = makePTR(hp+268);
hp[276] = makeHDR(3);
hp[277] = makeCTR(C_Cons);
hp[278] = makeINT(101);
hp[279] = makeCTR(C_Nil);
hp[280] = makeHDR(3);
hp[281] = makeCTR(C_Cons);
hp[282] = makeINT(99);
hp[283] = makePTR(hp+276);
hp[284] = makeHDR(3);
hp[285] = makeCTR(C_Cons);
hp[286] = makeINT(110);
hp[287] = makePTR(hp+280);
hp[288] = makeHDR(3);
hp[289] = makeCTR(C_Cons);
hp[290] = makeINT(97);
hp[291] = makePTR(hp+284);
hp[292] = makeHDR(3);
hp[293] = makeCTR(C_Cons);
hp[294] = makeINT(116);
hp[295] = makePTR(hp+288);
hp[296] = makeHDR(3);
hp[297] = makeCTR(C_Cons);
hp[298] = makeINT(115);
hp[299] = makePTR(hp+292);
hp[300] = makeHDR(3);
hp[301] = makeCTR(C_Cons);
hp[302] = makeINT(110);
hp[303] = makePTR(hp+296);
hp[304] = makeHDR(3);
hp[305] = makeCTR(C_Cons);
hp[306] = makeINT(105);
hp[307] = makePTR(hp+300);
hp[308] = makeHDR(3);
hp[309] = makeCTR(C_Cons);
hp[310] = makeINT(116);
hp[311] = makeCTR(C_Nil);
hp[312] = makeHDR(3);
hp[313] = makeCTR(C_Cons);
hp[314] = makeINT(101);
hp[315] = makePTR(hp+308);
hp[316] = makeHDR(3);
hp[317] = makeCTR(C_Cons);
hp[318] = makeINT(108);
hp[319] = makePTR(hp+312);
hp[320] = makeHDR(3);
hp[321] = makeCTR(C_Cons);
hp[322] = makeINT(101);
hp[323] = makeCTR(C_Nil);
hp[324] = makeHDR(3);
hp[325] = makeCTR(C_Cons);
hp[326] = makeINT(108);
hp[327] = makePTR(hp+320);
hp[328] = makeHDR(3);
hp[329] = makeCTR(C_Cons);
hp[330] = makeINT(117);
hp[331] = makePTR(hp+324);
hp[332] = makeHDR(3);
hp[333] = makeCTR(C_Cons);
hp[334] = makeINT(100);
hp[335] = makePTR(hp+328);
hp[336] = makeHDR(3);
hp[337] = makeCTR(C_Cons);
hp[338] = makeINT(111);
hp[339] = makePTR(hp+332);
hp[340] = makeHDR(3);
hp[341] = makeCTR(C_Cons);
hp[342] = makeINT(109);
hp[343] = makePTR(hp+336);
hp[344] = makeHDR(3);
hp[345] = makeCTR(C_Cons);
hp[346] = makeINT(101);
hp[347] = makeCTR(C_Nil);
hp[348] = makeHDR(3);
hp[349] = makeCTR(C_Cons);
hp[350] = makeINT(112);
hp[351] = makePTR(hp+344);
hp[352] = makeHDR(3);
hp[353] = makeCTR(C_Cons);
hp[354] = makeINT(121);
hp[355] = makePTR(hp+348);
hp[356] = makeHDR(3);
hp[357] = makeCTR(C_Cons);
hp[358] = makeINT(116);
hp[359] = makePTR(hp+352);
hp[360] = makeHDR(3);
hp[361] = makeCTR(C_Cons);
hp[362] = makeINT(119);
hp[363] = makePTR(hp+356);
hp[364] = makeHDR(3);
hp[365] = makeCTR(C_Cons);
hp[366] = makeINT(101);
hp[367] = makePTR(hp+360);
hp[368] = makeHDR(3);
hp[369] = makeCTR(C_Cons);
hp[370] = makeINT(110);
hp[371] = makePTR(hp+364);
hp[372] = makeHDR(3);
hp[373] = makeCTR(C_Cons);
hp[374] = makeINT(102);
hp[375] = makeCTR(C_Nil);
hp[376] = makeHDR(3);
hp[377] = makeCTR(C_Cons);
hp[378] = makeINT(111);
hp[379] = makePTR(hp+372);
hp[380] = makeHDR(3);
hp[381] = makeCTR(C_Cons);
hp[382] = makeINT(100);
hp[383] = makeCTR(C_Nil);
hp[384] = makeHDR(3);
hp[385] = makeCTR(C_Cons);
hp[386] = makeINT(101);
hp[387] = makePTR(hp+380);
hp[388] = makeHDR(3);
hp[389] = makeCTR(C_Cons);
hp[390] = makeINT(105);
hp[391] = makePTR(hp+384);
hp[392] = makeHDR(3);
hp[393] = makeCTR(C_Cons);
hp[394] = makeINT(102);
hp[395] = makePTR(hp+388);
hp[396] = makeHDR(3);
hp[397] = makeCTR(C_Cons);
hp[398] = makeINT(105);
hp[399] = makePTR(hp+392);
hp[400] = makeHDR(3);
hp[401] = makeCTR(C_Cons);
hp[402] = makeINT(108);
hp[403] = makePTR(hp+396);
hp[404] = makeHDR(3);
hp[405] = makeCTR(C_Cons);
hp[406] = makeINT(97);
hp[407] = makePTR(hp+400);
hp[408] = makeHDR(3);
hp[409] = makeCTR(C_Cons);
hp[410] = makeINT(117);
hp[411] = makePTR(hp+404);
hp[412] = makeHDR(3);
hp[413] = makeCTR(C_Cons);
hp[414] = makeINT(113);
hp[415] = makePTR(hp+408);
hp[416] = makeHDR(3);
hp[417] = makeCTR(C_Cons);
hp[418] = makeINT(110);
hp[419] = makeCTR(C_Nil);
hp[420] = makeHDR(3);
hp[421] = makeCTR(C_Cons);
hp[422] = makeINT(101);
hp[423] = makePTR(hp+416);
hp[424] = makeHDR(3);
hp[425] = makeCTR(C_Cons);
hp[426] = makeINT(104);
hp[427] = makePTR(hp+420);
hp[428] = makeHDR(3);
hp[429] = makeCTR(C_Cons);
hp[430] = makeINT(116);
hp[431] = makePTR(hp+424);
hp[432] = makeHDR(3);
hp[433] = makeCTR(C_Cons);
hp[434] = makeINT(101);
hp[435] = makeCTR(C_Nil);
hp[436] = makeHDR(3);
hp[437] = makeCTR(C_Cons);
hp[438] = makeINT(112);
hp[439] = makePTR(hp+432);
hp[440] = makeHDR(3);
hp[441] = makeCTR(C_Cons);
hp[442] = makeINT(121);
hp[443] = makePTR(hp+436);
hp[444] = makeHDR(3);
hp[445] = makeCTR(C_Cons);
hp[446] = makeINT(116);
hp[447] = makePTR(hp+440);
hp[448] = makeHDR(3);
hp[449] = makeCTR(C_Cons);
hp[450] = makeINT(101);
hp[451] = makeCTR(C_Nil);
hp[452] = makeHDR(3);
hp[453] = makeCTR(C_Cons);
hp[454] = makeINT(114);
hp[455] = makePTR(hp+448);
hp[456] = makeHDR(3);
hp[457] = makeCTR(C_Cons);
hp[458] = makeINT(101);
hp[459] = makePTR(hp+452);
hp[460] = makeHDR(3);
hp[461] = makeCTR(C_Cons);
hp[462] = makeINT(104);
hp[463] = makePTR(hp+456);
hp[464] = makeHDR(3);
hp[465] = makeCTR(C_Cons);
hp[466] = makeINT(119);
hp[467] = makePTR(hp+460);
hp[468] = makeHDR(3);
hp[469] = makeCTR(C_Cons);
hp[470] = makePTR(hp+464);
hp[471] = makeCTR(C_Nil);
hp[472] = makeHDR(3);
hp[473] = makeCTR(C_Cons);
hp[474] = makePTR(hp+444);
hp[475] = makePTR(hp+468);
hp[476] = makeHDR(3);
hp[477] = makeCTR(C_Cons);
hp[478] = makePTR(hp+428);
hp[479] = makePTR(hp+472);
hp[480] = makeHDR(3);
hp[481] = makeCTR(C_Cons);
hp[482] = makePTR(hp+412);
hp[483] = makePTR(hp+476);
hp[484] = makeHDR(3);
hp[485] = makeCTR(C_Cons);
hp[486] = makePTR(hp+376);
hp[487] = makePTR(hp+480);
hp[488] = makeHDR(3);
hp[489] = makeCTR(C_Cons);
hp[490] = makePTR(hp+368);
hp[491] = makePTR(hp+484);
hp[492] = makeHDR(3);
hp[493] = makeCTR(C_Cons);
hp[494] = makePTR(hp+340);
hp[495] = makePTR(hp+488);
hp[496] = makeHDR(3);
hp[497] = makeCTR(C_Cons);
hp[498] = makePTR(hp+316);
hp[499] = makePTR(hp+492);
hp[500] = makeHDR(3);
hp[501] = makeCTR(C_Cons);
hp[502] = makePTR(hp+304);
hp[503] = makePTR(hp+496);
hp[504] = makeHDR(3);
hp[505] = makeCTR(C_Cons);
hp[506] = makePTR(hp+272);
hp[507] = makePTR(hp+500);
hp[508] = makeHDR(3);
hp[509] = makeCTR(C_Cons);
hp[510] = makePTR(hp+248);
hp[511] = makePTR(hp+504);
hp[512] = makeHDR(3);
hp[513] = makeCTR(C_Cons);
hp[514] = makePTR(hp+224);
hp[515] = makePTR(hp+508);
hp[516] = makeHDR(3);
hp[517] = makeCTR(C_Cons);
hp[518] = makePTR(hp+204);
hp[519] = makePTR(hp+512);
hp[520] = makeHDR(3);
hp[521] = makeCTR(C_Cons);
hp[522] = makePTR(hp+196);
hp[523] = makePTR(hp+516);
hp[524] = makeHDR(3);
hp[525] = makeCTR(C_Cons);
hp[526] = makePTR(hp+172);
hp[527] = makePTR(hp+520);
hp[528] = makeHDR(3);
hp[529] = makeCTR(C_Cons);
hp[530] = makePTR(hp+164);
hp[531] = makePTR(hp+524);
hp[532] = makeHDR(3);
hp[533] = makeCTR(C_Cons);
hp[534] = makePTR(hp+140);
hp[535] = makePTR(hp+528);
hp[536] = makeHDR(3);
hp[537] = makeCTR(C_Cons);
hp[538] = makePTR(hp+124);
hp[539] = makePTR(hp+532);
hp[540] = makeHDR(3);
hp[541] = makeCTR(C_Cons);
hp[542] = makePTR(hp+116);
hp[543] = makePTR(hp+536);
hp[544] = makeHDR(3);
hp[545] = makeCTR(C_Cons);
hp[546] = makePTR(hp+84);
hp[547] = makePTR(hp+540);
hp[548] = makeHDR(3);
hp[549] = makeCTR(C_Cons);
hp[550] = makePTR(hp+56);
hp[551] = makePTR(hp+544);
hp[552] = makeHDR(3);
hp[553] = makeCTR(C_Cons);
hp[554] = makePTR(hp+40);
hp[555] = makePTR(hp+548);
hp[556] = makeHDR(3);
hp[557] = makeCTR(C_Cons);
hp[558] = makePTR(hp+20);
hp[559] = makePTR(hp+552);
hp[560] = makeHDR(3);
hp[561] = makeCTR(C_Cons);
hp[562] = makePTR(hp+4);
hp[563] = makePTR(hp+556);
hp[564] = makeHDR(2);
hp[565] = makeFUN(&&F_cichelli);
hp[566] = makePTR(hp+560);
atom = makePTR(hp+564);
hp += 567;
eval_ret_addr = &&LABEL_835;
goto EVAL;
LABEL_835:
switch (res) {
case C_Just:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_emitHashFun);
hp[2] = getPTR(L_sp[-1])[2];
atom = makePTR(hp+0);
hp += 3;
L_POP(2);
L_PUSH(atom);
goto F_emitHashFun;
case C_Nothing:
L_POP(2);
L_PUSH(makeINT(0));
res = 0;
goto EVAL_RET;
}
F_min:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_836;
  goto GC_COLLECT;
}
  GC_RET_836:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_837;
goto EVAL;
LABEL_837:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_838;
goto EVAL;
LABEL_838:
L_POP(1);
res = getINT(L_top) <= res ? C_True : C_False;
L_POP(1);
L_PUSH(makeCTR(res));
switch (res) {
case C_True:
atom = getPTR(L_sp[-2])[2];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
case C_False:
atom = getPTR(L_sp[-2])[3];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_max:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_839;
  goto GC_COLLECT;
}
  GC_RET_839:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_840;
goto EVAL;
LABEL_840:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_841;
goto EVAL;
LABEL_841:
L_POP(1);
res = getINT(L_top) <= res ? C_True : C_False;
L_POP(1);
L_PUSH(makeCTR(res));
switch (res) {
case C_True:
atom = getPTR(L_sp[-2])[3];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
case C_False:
atom = getPTR(L_sp[-2])[2];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_gt:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_842;
  goto GC_COLLECT;
}
  GC_RET_842:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_843;
goto EVAL;
LABEL_843:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_844;
goto EVAL;
LABEL_844:
L_POP(1);
res = getINT(L_top) <= res ? C_True : C_False;
L_POP(1);
L_PUSH(makeCTR(res));
switch (res) {
case C_True:
L_POP(2);
L_PUSH(makeCTR(C_False));
res = C_False;
goto EVAL_RET;
case C_False:
L_POP(2);
L_PUSH(makeCTR(C_True));
res = C_True;
goto EVAL_RET;
}
F_head:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_845;
  goto GC_COLLECT;
}
  GC_RET_845:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_846;
goto EVAL;
LABEL_846:
switch (res) {
case C_Cons:
atom = getPTR(L_sp[-1])[2];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_last:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_847;
  goto GC_COLLECT;
}
  GC_RET_847:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_848;
goto EVAL;
LABEL_848:
switch (res) {
case C_Cons:
atom = getPTR(L_sp[-1])[3];
eval_ret_addr = &&LABEL_849;
goto EVAL;
LABEL_849:
switch (res) {
case C_Nil:
atom = getPTR(L_sp[-2])[2];
L_POP(3);
goto TAIL_EVAL;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_last);
hp[2] = getPTR(L_sp[-2])[3];
atom = makePTR(hp+0);
hp += 3;
L_POP(3);
L_PUSH(atom);
goto F_last;
}
}
F_null:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_850;
  goto GC_COLLECT;
}
  GC_RET_850:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_851;
goto EVAL;
LABEL_851:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_True));
res = C_True;
goto EVAL_RET;
case C_Cons:
L_POP(2);
L_PUSH(makeCTR(C_False));
res = C_False;
goto EVAL_RET;
}
F_length:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_852;
  goto GC_COLLECT;
}
  GC_RET_852:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_lengthAcc);
hp[2] = makeINT(0);
hp[3] = getPTR(L_sp[-1])[2];
atom = makePTR(hp+0);
hp += 4;
L_POP(1);
L_PUSH(atom);
goto F_lengthAcc;
F_lengthAcc:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_853;
  goto GC_COLLECT;
}
  GC_RET_853:
atom = getPTR(L_sp[-1])[3];
getPTR(L_sp[-1])[3] = makeINT(0);
eval_ret_addr = &&LABEL_854;
goto EVAL;
LABEL_854:
switch (res) {
case C_Nil:
atom = getPTR(L_sp[-2])[2];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&P_ADD);
hp[2] = getPTR(L_sp[-2])[2];
hp[3] = makeINT(1);
hp[4] = makeHDR(3);
hp[5] = makeFUN(&&F_lengthAcc);
hp[6] = makePTR(hp+0);
hp[7] = getPTR(L_sp[-1])[3];
atom = makePTR(hp+4);
hp += 8;
L_POP(2);
L_PUSH(atom);
goto F_lengthAcc;
}
F_append:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_856;
  goto GC_COLLECT;
}
  GC_RET_856:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_857;
goto EVAL;
LABEL_857:
switch (res) {
case C_Nil:
atom = getPTR(L_sp[-2])[3];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_append);
hp[2] = getPTR(L_sp[-1])[3];
hp[3] = getPTR(L_sp[-2])[3];
hp[4] = makeHDR(3);
hp[5] = makeCTR(C_Cons);
hp[6] = getPTR(L_sp[-1])[2];
hp[7] = makePTR(hp+0);
atom = makePTR(hp+4);
hp += 8;
L_POP(2);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
}
F_mapAssign:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_859;
  goto GC_COLLECT;
}
  GC_RET_859:
atom = getPTR(L_sp[-1])[4];
getPTR(L_sp[-1])[4] = makeINT(0);
eval_ret_addr = &&LABEL_860;
goto EVAL;
LABEL_860:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(4);
hp[1] = makeFUN(&&F_mapAssign___0);
hp[2] = getPTR(L_sp[-2])[3];
hp[3] = getPTR(L_sp[-2])[2];
hp[4] = getPTR(L_sp[-1])[2];
hp[5] = makeHDR(4);
hp[6] = makeFUN(&&F_mapAssign);
hp[7] = getPTR(L_sp[-2])[2];
hp[8] = getPTR(L_sp[-2])[3];
hp[9] = getPTR(L_sp[-1])[3];
hp[10] = makeHDR(3);
hp[11] = makeCTR(C_Cons);
hp[12] = makePTR(hp+0);
hp[13] = makePTR(hp+5);
atom = makePTR(hp+10);
hp += 14;
L_POP(2);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
}
F_mapAssign___0:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_863;
  goto GC_COLLECT;
}
  GC_RET_863:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_864;
goto EVAL;
LABEL_864:
switch (res) {
case C_Hash:
hp[0] = makeHDR(3);
hp[1] = makeCTR(C_Pair);
hp[2] = getPTR(L_sp[-2])[3];
hp[3] = getPTR(L_sp[-2])[4];
hp[4] = makeHDR(3);
hp[5] = makeCTR(C_Cons);
hp[6] = makePTR(hp+0);
hp[7] = getPTR(L_sp[-1])[3];
hp[8] = makeHDR(3);
hp[9] = makeCTR(C_Hash);
hp[10] = getPTR(L_sp[-1])[2];
hp[11] = makePTR(hp+4);
atom = makePTR(hp+8);
hp += 12;
L_POP(2);
L_PUSH(atom);
res = C_Hash;
goto EVAL_RET;
}
F_mapEnKey:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_867;
  goto GC_COLLECT;
}
  GC_RET_867:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_868;
goto EVAL;
LABEL_868:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_enKey);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = makeHDR(2);
hp[4] = makeFUN(&&F_mapEnKey);
hp[5] = getPTR(L_sp[-1])[3];
hp[6] = makeHDR(3);
hp[7] = makeCTR(C_Cons);
hp[8] = makePTR(hp+0);
hp[9] = makePTR(hp+3);
atom = makePTR(hp+6);
hp += 10;
L_POP(2);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
}
F_concatMapEnds:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_871;
  goto GC_COLLECT;
}
  GC_RET_871:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_872;
goto EVAL;
LABEL_872:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_concatMapEnds___0);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = makeHDR(2);
hp[4] = makeFUN(&&F_concatMapEnds);
hp[5] = getPTR(L_sp[-1])[3];
hp[6] = makeHDR(3);
hp[7] = makeFUN(&&F_append);
hp[8] = makePTR(hp+0);
hp[9] = makePTR(hp+3);
atom = makePTR(hp+6);
hp += 10;
L_POP(2);
L_PUSH(atom);
goto F_append;
}
F_concatMapEnds___0:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_875;
  goto GC_COLLECT;
}
  GC_RET_875:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_876;
goto EVAL;
LABEL_876:
switch (res) {
case C_K:
hp[0] = makeHDR(3);
hp[1] = makeCTR(C_Cons);
hp[2] = getPTR(L_sp[-1])[4];
hp[3] = makeCTR(C_Nil);
hp[4] = makeHDR(3);
hp[5] = makeCTR(C_Cons);
hp[6] = getPTR(L_sp[-1])[3];
hp[7] = makePTR(hp+0);
atom = makePTR(hp+4);
hp += 8;
L_POP(2);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
}
F_concatMapHashes:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_878;
  goto GC_COLLECT;
}
  GC_RET_878:
atom = getPTR(L_sp[-1])[5];
getPTR(L_sp[-1])[5] = makeINT(0);
eval_ret_addr = &&LABEL_879;
goto EVAL;
LABEL_879:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(5);
hp[1] = makeFUN(&&F_hashes);
hp[2] = getPTR(L_sp[-2])[2];
hp[3] = getPTR(L_sp[-2])[3];
hp[4] = getPTR(L_sp[-2])[4];
hp[5] = getPTR(L_sp[-1])[2];
hp[6] = makeHDR(5);
hp[7] = makeFUN(&&F_concatMapHashes);
hp[8] = getPTR(L_sp[-2])[2];
hp[9] = getPTR(L_sp[-2])[3];
hp[10] = getPTR(L_sp[-2])[4];
hp[11] = getPTR(L_sp[-1])[3];
hp[12] = makeHDR(3);
hp[13] = makeFUN(&&F_append);
hp[14] = makePTR(hp+0);
hp[15] = makePTR(hp+6);
atom = makePTR(hp+12);
hp += 16;
L_POP(2);
L_PUSH(atom);
goto F_append;
}
F_concatMapInsertKey:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_882;
  goto GC_COLLECT;
}
  GC_RET_882:
atom = getPTR(L_sp[-1])[4];
getPTR(L_sp[-1])[4] = makeINT(0);
eval_ret_addr = &&LABEL_883;
goto EVAL;
LABEL_883:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(4);
hp[1] = makeFUN(&&F_insertKey);
hp[2] = getPTR(L_sp[-2])[2];
hp[3] = getPTR(L_sp[-2])[3];
hp[4] = getPTR(L_sp[-1])[2];
hp[5] = makeHDR(4);
hp[6] = makeFUN(&&F_concatMapInsertKey);
hp[7] = getPTR(L_sp[-2])[2];
hp[8] = getPTR(L_sp[-2])[3];
hp[9] = getPTR(L_sp[-1])[3];
hp[10] = makeHDR(3);
hp[11] = makeFUN(&&F_append);
hp[12] = makePTR(hp+0);
hp[13] = makePTR(hp+5);
atom = makePTR(hp+10);
hp += 14;
L_POP(2);
L_PUSH(atom);
goto F_append;
}
F_concatMapAssignUpto:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_886;
  goto GC_COLLECT;
}
  GC_RET_886:
atom = getPTR(L_sp[-1])[4];
getPTR(L_sp[-1])[4] = makeINT(0);
eval_ret_addr = &&LABEL_887;
goto EVAL;
LABEL_887:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(4);
hp[1] = makeFUN(&&F_assignUpto);
hp[2] = getPTR(L_sp[-2])[2];
hp[3] = getPTR(L_sp[-2])[3];
hp[4] = getPTR(L_sp[-1])[2];
hp[5] = makeHDR(4);
hp[6] = makeFUN(&&F_concatMapAssignUpto);
hp[7] = getPTR(L_sp[-2])[2];
hp[8] = getPTR(L_sp[-2])[3];
hp[9] = getPTR(L_sp[-1])[3];
hp[10] = makeHDR(3);
hp[11] = makeFUN(&&F_append);
hp[12] = makePTR(hp+0);
hp[13] = makePTR(hp+5);
atom = makePTR(hp+10);
hp += 14;
L_POP(2);
L_PUSH(atom);
goto F_append;
}
F_elem:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_890;
  goto GC_COLLECT;
}
  GC_RET_890:
atom = getPTR(L_sp[-1])[3];
getPTR(L_sp[-1])[3] = makeINT(0);
eval_ret_addr = &&LABEL_891;
goto EVAL;
LABEL_891:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_False));
res = C_False;
goto EVAL_RET;
case C_Cons:
atom = getPTR(L_sp[-2])[2];
eval_ret_addr = &&LABEL_892;
goto EVAL;
LABEL_892:
atom = getPTR(L_sp[-2])[2];
eval_ret_addr = &&LABEL_893;
goto EVAL;
LABEL_893:
L_POP(1);
res = getINT(L_top) == res ? C_True : C_False;
L_POP(1);
L_PUSH(makeCTR(res));
switch (res) {
case C_True:
L_POP(3);
L_PUSH(makeCTR(C_True));
res = C_True;
goto EVAL_RET;
case C_False:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_elem);
hp[2] = getPTR(L_sp[-3])[2];
hp[3] = getPTR(L_sp[-2])[3];
atom = makePTR(hp+0);
hp += 4;
L_POP(3);
L_PUSH(atom);
goto F_elem;
}
}
F_filterEks:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_894;
  goto GC_COLLECT;
}
  GC_RET_894:
atom = getPTR(L_sp[-1])[3];
getPTR(L_sp[-1])[3] = makeINT(0);
eval_ret_addr = &&LABEL_895;
goto EVAL;
LABEL_895:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_filterEks___0);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = makeHDR(3);
hp[4] = makeFUN(&&F_subset);
hp[5] = makePTR(hp+0);
hp[6] = getPTR(L_sp[-2])[2];
atom = makePTR(hp+3);
hp += 7;
eval_ret_addr = &&LABEL_897;
goto EVAL;
LABEL_897:
switch (res) {
case C_True:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_filterEks);
hp[2] = getPTR(L_sp[-3])[2];
hp[3] = getPTR(L_sp[-2])[3];
hp[4] = makeHDR(3);
hp[5] = makeCTR(C_Cons);
hp[6] = getPTR(L_sp[-2])[2];
hp[7] = makePTR(hp+0);
atom = makePTR(hp+4);
hp += 8;
L_POP(3);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
case C_False:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_filterEks);
hp[2] = getPTR(L_sp[-3])[2];
hp[3] = getPTR(L_sp[-2])[3];
atom = makePTR(hp+0);
hp += 4;
L_POP(3);
L_PUSH(atom);
goto F_filterEks;
}
}
F_filterEks___0:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_899;
  goto GC_COLLECT;
}
  GC_RET_899:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_900;
goto EVAL;
LABEL_900:
switch (res) {
case C_K:
hp[0] = makeHDR(3);
hp[1] = makeCTR(C_Cons);
hp[2] = getPTR(L_sp[-1])[4];
hp[3] = makeCTR(C_Nil);
hp[4] = makeHDR(3);
hp[5] = makeCTR(C_Cons);
hp[6] = getPTR(L_sp[-1])[3];
hp[7] = makePTR(hp+0);
atom = makePTR(hp+4);
hp += 8;
L_POP(2);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
}
F_filterNonEks:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_902;
  goto GC_COLLECT;
}
  GC_RET_902:
atom = getPTR(L_sp[-1])[3];
getPTR(L_sp[-1])[3] = makeINT(0);
eval_ret_addr = &&LABEL_903;
goto EVAL;
LABEL_903:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_filterNonEks___0);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = makeHDR(3);
hp[4] = makeFUN(&&F_subset);
hp[5] = makePTR(hp+0);
hp[6] = getPTR(L_sp[-2])[2];
atom = makePTR(hp+3);
hp += 7;
eval_ret_addr = &&LABEL_905;
goto EVAL;
LABEL_905:
switch (res) {
case C_False:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_filterNonEks);
hp[2] = getPTR(L_sp[-3])[2];
hp[3] = getPTR(L_sp[-2])[3];
hp[4] = makeHDR(3);
hp[5] = makeCTR(C_Cons);
hp[6] = getPTR(L_sp[-2])[2];
hp[7] = makePTR(hp+0);
atom = makePTR(hp+4);
hp += 8;
L_POP(3);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
case C_True:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_filterNonEks);
hp[2] = getPTR(L_sp[-3])[2];
hp[3] = getPTR(L_sp[-2])[3];
atom = makePTR(hp+0);
hp += 4;
L_POP(3);
L_PUSH(atom);
goto F_filterNonEks;
}
}
F_filterNonEks___0:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_907;
  goto GC_COLLECT;
}
  GC_RET_907:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_908;
goto EVAL;
LABEL_908:
switch (res) {
case C_K:
hp[0] = makeHDR(3);
hp[1] = makeCTR(C_Cons);
hp[2] = getPTR(L_sp[-1])[4];
hp[3] = makeCTR(C_Nil);
hp[4] = makeHDR(3);
hp[5] = makeCTR(C_Cons);
hp[6] = getPTR(L_sp[-1])[3];
hp[7] = makePTR(hp+0);
atom = makePTR(hp+4);
hp += 8;
L_POP(2);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
}
F_enumFromTo:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_910;
  goto GC_COLLECT;
}
  GC_RET_910:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_911;
goto EVAL;
LABEL_911:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_912;
goto EVAL;
LABEL_912:
L_POP(1);
res = getINT(L_top) <= res ? C_True : C_False;
L_POP(1);
L_PUSH(makeCTR(res));
switch (res) {
case C_True:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&P_ADD);
hp[2] = getPTR(L_sp[-2])[2];
hp[3] = makeINT(1);
hp[4] = makeHDR(3);
hp[5] = makeFUN(&&F_enumFromTo);
hp[6] = makePTR(hp+0);
hp[7] = getPTR(L_sp[-2])[3];
hp[8] = makeHDR(3);
hp[9] = makeCTR(C_Cons);
hp[10] = getPTR(L_sp[-2])[2];
hp[11] = makePTR(hp+4);
atom = makePTR(hp+8);
hp += 12;
L_POP(2);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
case C_False:
L_POP(2);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
}
F_assoc:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_915;
  goto GC_COLLECT;
}
  GC_RET_915:
atom = getPTR(L_sp[-1])[3];
getPTR(L_sp[-1])[3] = makeINT(0);
eval_ret_addr = &&LABEL_916;
goto EVAL;
LABEL_916:
switch (res) {
case C_Cons:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_917;
goto EVAL;
LABEL_917:
switch (res) {
case C_Pair:
atom = getPTR(L_sp[-3])[2];
eval_ret_addr = &&LABEL_918;
goto EVAL;
LABEL_918:
atom = getPTR(L_sp[-2])[2];
eval_ret_addr = &&LABEL_919;
goto EVAL;
LABEL_919:
L_POP(1);
res = getINT(L_top) == res ? C_True : C_False;
L_POP(1);
L_PUSH(makeCTR(res));
switch (res) {
case C_True:
atom = getPTR(L_sp[-2])[3];
L_POP(4);
goto TAIL_EVAL;
goto EVAL_RET;
case C_False:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_assoc);
hp[2] = getPTR(L_sp[-4])[2];
hp[3] = getPTR(L_sp[-3])[3];
atom = makePTR(hp+0);
hp += 4;
L_POP(4);
L_PUSH(atom);
goto F_assoc;
}
}
}
F_assocm:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_920;
  goto GC_COLLECT;
}
  GC_RET_920:
atom = getPTR(L_sp[-1])[3];
getPTR(L_sp[-1])[3] = makeINT(0);
eval_ret_addr = &&LABEL_921;
goto EVAL;
LABEL_921:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_Nothing));
res = C_Nothing;
goto EVAL_RET;
case C_Cons:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_922;
goto EVAL;
LABEL_922:
switch (res) {
case C_Pair:
atom = getPTR(L_sp[-3])[2];
eval_ret_addr = &&LABEL_923;
goto EVAL;
LABEL_923:
atom = getPTR(L_sp[-2])[2];
eval_ret_addr = &&LABEL_924;
goto EVAL;
LABEL_924:
L_POP(1);
res = getINT(L_top) == res ? C_True : C_False;
L_POP(1);
L_PUSH(makeCTR(res));
switch (res) {
case C_True:
hp[0] = makeHDR(2);
hp[1] = makeCTR(C_Just);
hp[2] = getPTR(L_sp[-2])[3];
atom = makePTR(hp+0);
hp += 3;
L_POP(4);
L_PUSH(atom);
res = C_Just;
goto EVAL_RET;
case C_False:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_assocm);
hp[2] = getPTR(L_sp[-4])[2];
hp[3] = getPTR(L_sp[-3])[3];
atom = makePTR(hp+0);
hp += 4;
L_POP(4);
L_PUSH(atom);
goto F_assocm;
}
}
}
F_subset:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_925;
  goto GC_COLLECT;
}
  GC_RET_925:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_926;
goto EVAL;
LABEL_926:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_True));
res = C_True;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_elem);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = getPTR(L_sp[-2])[3];
atom = makePTR(hp+0);
hp += 4;
eval_ret_addr = &&LABEL_927;
goto EVAL;
LABEL_927:
switch (res) {
case C_True:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_subset);
hp[2] = getPTR(L_sp[-2])[3];
hp[3] = getPTR(L_sp[-3])[3];
atom = makePTR(hp+0);
hp += 4;
L_POP(3);
L_PUSH(atom);
goto F_subset;
case C_False:
L_POP(3);
L_PUSH(makeCTR(C_False));
res = C_False;
goto EVAL_RET;
}
}
F_union:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_928;
  goto GC_COLLECT;
}
  GC_RET_928:
atom = getPTR(L_sp[-1])[3];
getPTR(L_sp[-1])[3] = makeINT(0);
eval_ret_addr = &&LABEL_929;
goto EVAL;
LABEL_929:
switch (res) {
case C_Nil:
atom = getPTR(L_sp[-2])[2];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_union);
hp[2] = getPTR(L_sp[-2])[2];
hp[3] = getPTR(L_sp[-1])[3];
hp[4] = makeHDR(3);
hp[5] = makeFUN(&&F_ins);
hp[6] = getPTR(L_sp[-1])[2];
hp[7] = makePTR(hp+0);
atom = makePTR(hp+4);
hp += 8;
L_POP(2);
L_PUSH(atom);
goto F_ins;
}
F_ins:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_931;
  goto GC_COLLECT;
}
  GC_RET_931:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_elem);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = getPTR(L_sp[-1])[3];
atom = makePTR(hp+0);
hp += 4;
eval_ret_addr = &&LABEL_932;
goto EVAL;
LABEL_932:
switch (res) {
case C_True:
atom = getPTR(L_sp[-2])[3];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
case C_False:
hp[0] = makeHDR(3);
hp[1] = makeCTR(C_Cons);
hp[2] = getPTR(L_sp[-2])[2];
hp[3] = getPTR(L_sp[-2])[3];
atom = makePTR(hp+0);
hp += 4;
L_POP(2);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
}
F_histo:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_933;
  goto GC_COLLECT;
}
  GC_RET_933:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_934;
goto EVAL;
LABEL_934:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_histo);
hp[2] = getPTR(L_sp[-1])[3];
hp[3] = makeHDR(3);
hp[4] = makeFUN(&&F_histins);
hp[5] = getPTR(L_sp[-1])[2];
hp[6] = makePTR(hp+0);
atom = makePTR(hp+3);
hp += 7;
L_POP(2);
L_PUSH(atom);
goto F_histins;
}
F_histins:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_936;
  goto GC_COLLECT;
}
  GC_RET_936:
atom = getPTR(L_sp[-1])[3];
getPTR(L_sp[-1])[3] = makeINT(0);
eval_ret_addr = &&LABEL_937;
goto EVAL;
LABEL_937:
switch (res) {
case C_Nil:
hp[0] = makeHDR(3);
hp[1] = makeCTR(C_Pair);
hp[2] = getPTR(L_sp[-2])[2];
hp[3] = makeINT(1);
hp[4] = makeHDR(3);
hp[5] = makeCTR(C_Cons);
hp[6] = makePTR(hp+0);
hp[7] = makeCTR(C_Nil);
atom = makePTR(hp+4);
hp += 8;
L_POP(2);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
case C_Cons:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_939;
goto EVAL;
LABEL_939:
switch (res) {
case C_Pair:
atom = getPTR(L_sp[-3])[2];
eval_ret_addr = &&LABEL_940;
goto EVAL;
LABEL_940:
atom = getPTR(L_sp[-2])[2];
eval_ret_addr = &&LABEL_941;
goto EVAL;
LABEL_941:
L_POP(1);
res = getINT(L_top) == res ? C_True : C_False;
L_POP(1);
L_PUSH(makeCTR(res));
switch (res) {
case C_True:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&P_ADD);
hp[2] = getPTR(L_sp[-2])[3];
hp[3] = makeINT(1);
hp[4] = makeHDR(3);
hp[5] = makeCTR(C_Pair);
hp[6] = getPTR(L_sp[-2])[2];
hp[7] = makePTR(hp+0);
hp[8] = makeHDR(3);
hp[9] = makeCTR(C_Cons);
hp[10] = makePTR(hp+4);
hp[11] = getPTR(L_sp[-3])[3];
atom = makePTR(hp+8);
hp += 12;
L_POP(4);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
case C_False:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_histins);
hp[2] = getPTR(L_sp[-4])[2];
hp[3] = getPTR(L_sp[-3])[3];
hp[4] = makeHDR(3);
hp[5] = makeCTR(C_Cons);
hp[6] = getPTR(L_sp[-3])[2];
hp[7] = makePTR(hp+0);
atom = makePTR(hp+4);
hp += 8;
L_POP(4);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
}
}
}
F_sortedDF:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_945;
  goto GC_COLLECT;
}
  GC_RET_945:
atom = getPTR(L_sp[-1])[3];
getPTR(L_sp[-1])[3] = makeINT(0);
eval_ret_addr = &&LABEL_946;
goto EVAL;
LABEL_946:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_sortedDF);
hp[2] = getPTR(L_sp[-2])[2];
hp[3] = getPTR(L_sp[-1])[3];
hp[4] = makeHDR(4);
hp[5] = makeFUN(&&F_ordinsDF);
hp[6] = getPTR(L_sp[-2])[2];
hp[7] = getPTR(L_sp[-1])[2];
hp[8] = makePTR(hp+0);
atom = makePTR(hp+4);
hp += 9;
L_POP(2);
L_PUSH(atom);
goto F_ordinsDF;
}
F_ordinsDF:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_948;
  goto GC_COLLECT;
}
  GC_RET_948:
atom = getPTR(L_sp[-1])[4];
getPTR(L_sp[-1])[4] = makeINT(0);
eval_ret_addr = &&LABEL_949;
goto EVAL;
LABEL_949:
switch (res) {
case C_Nil:
hp[0] = makeHDR(3);
hp[1] = makeCTR(C_Cons);
hp[2] = getPTR(L_sp[-2])[3];
hp[3] = makeCTR(C_Nil);
atom = makePTR(hp+0);
hp += 4;
L_POP(2);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(4);
hp[1] = makeFUN(&&F_decreasingFrequencyIn);
hp[2] = getPTR(L_sp[-2])[2];
hp[3] = getPTR(L_sp[-2])[3];
hp[4] = getPTR(L_sp[-1])[2];
atom = makePTR(hp+0);
hp += 5;
eval_ret_addr = &&LABEL_950;
goto EVAL;
LABEL_950:
switch (res) {
case C_True:
hp[0] = makeHDR(3);
hp[1] = makeCTR(C_Cons);
hp[2] = getPTR(L_sp[-2])[2];
hp[3] = getPTR(L_sp[-2])[3];
hp[4] = makeHDR(3);
hp[5] = makeCTR(C_Cons);
hp[6] = getPTR(L_sp[-3])[3];
hp[7] = makePTR(hp+0);
atom = makePTR(hp+4);
hp += 8;
L_POP(3);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
case C_False:
hp[0] = makeHDR(4);
hp[1] = makeFUN(&&F_ordinsDF);
hp[2] = getPTR(L_sp[-3])[2];
hp[3] = getPTR(L_sp[-3])[3];
hp[4] = getPTR(L_sp[-2])[3];
hp[5] = makeHDR(3);
hp[6] = makeCTR(C_Cons);
hp[7] = getPTR(L_sp[-2])[2];
hp[8] = makePTR(hp+0);
atom = makePTR(hp+5);
hp += 9;
L_POP(3);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
}
}
F_ends:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_953;
  goto GC_COLLECT;
}
  GC_RET_953:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_954;
goto EVAL;
LABEL_954:
switch (res) {
case C_K:
hp[0] = makeHDR(3);
hp[1] = makeCTR(C_Cons);
hp[2] = getPTR(L_sp[-1])[4];
hp[3] = makeCTR(C_Nil);
hp[4] = makeHDR(3);
hp[5] = makeCTR(C_Cons);
hp[6] = getPTR(L_sp[-1])[3];
hp[7] = makePTR(hp+0);
atom = makePTR(hp+4);
hp += 8;
L_POP(2);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
}
F_firstLetter:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_956;
  goto GC_COLLECT;
}
  GC_RET_956:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_957;
goto EVAL;
LABEL_957:
switch (res) {
case C_K:
atom = getPTR(L_sp[-1])[3];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_lastLetter:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_958;
  goto GC_COLLECT;
}
  GC_RET_958:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_959;
goto EVAL;
LABEL_959:
switch (res) {
case C_K:
atom = getPTR(L_sp[-1])[4];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_freqSorted:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_960;
  goto GC_COLLECT;
}
  GC_RET_960:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_concatMapEnds);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = makeHDR(2);
hp[4] = makeFUN(&&F_histo);
hp[5] = makePTR(hp+0);
hp[6] = makeHDR(3);
hp[7] = makeFUN(&&F_sortedDF);
hp[8] = makePTR(hp+3);
hp[9] = getPTR(L_sp[-1])[2];
hp[10] = makeHDR(3);
hp[11] = makeFUN(&&F_lengthAcc);
hp[12] = makeINT(0);
hp[13] = makePTR(hp+3);
hp[14] = makeHDR(3);
hp[15] = makeCTR(C_Pair);
hp[16] = makePTR(hp+6);
hp[17] = makePTR(hp+10);
atom = makePTR(hp+14);
hp += 18;
L_POP(1);
L_PUSH(atom);
res = C_Pair;
goto EVAL_RET;
F_decreasingFrequencyIn:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_964;
  goto GC_COLLECT;
}
  GC_RET_964:
atom = getPTR(L_sp[-1])[3];
getPTR(L_sp[-1])[3] = makeINT(0);
eval_ret_addr = &&LABEL_965;
goto EVAL;
LABEL_965:
switch (res) {
case C_K:
atom = getPTR(L_sp[-2])[4];
getPTR(L_sp[-2])[4] = makeINT(0);
eval_ret_addr = &&LABEL_966;
goto EVAL;
LABEL_966:
switch (res) {
case C_K:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_assoc);
hp[2] = getPTR(L_sp[-2])[3];
hp[3] = getPTR(L_sp[-3])[2];
hp[4] = makeHDR(3);
hp[5] = makeFUN(&&F_assoc);
hp[6] = getPTR(L_sp[-2])[4];
hp[7] = getPTR(L_sp[-3])[2];
hp[8] = makeHDR(3);
hp[9] = makeFUN(&&P_ADD);
hp[10] = makePTR(hp+0);
hp[11] = makePTR(hp+4);
hp[12] = makeHDR(3);
hp[13] = makeFUN(&&F_assoc);
hp[14] = getPTR(L_sp[-1])[3];
hp[15] = getPTR(L_sp[-3])[2];
hp[16] = makeHDR(3);
hp[17] = makeFUN(&&F_assoc);
hp[18] = getPTR(L_sp[-1])[4];
hp[19] = getPTR(L_sp[-3])[2];
hp[20] = makeHDR(3);
hp[21] = makeFUN(&&P_ADD);
hp[22] = makePTR(hp+12);
hp[23] = makePTR(hp+16);
hp[24] = makeHDR(3);
hp[25] = makeFUN(&&F_gt);
hp[26] = makePTR(hp+8);
hp[27] = makePTR(hp+20);
atom = makePTR(hp+24);
hp += 28;
L_POP(3);
L_PUSH(atom);
goto F_gt;
}
}
F_freqTabOf:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_973;
  goto GC_COLLECT;
}
  GC_RET_973:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_concatMapEnds);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = makeHDR(2);
hp[4] = makeFUN(&&F_histo);
hp[5] = makePTR(hp+0);
atom = makePTR(hp+3);
hp += 6;
L_POP(1);
L_PUSH(atom);
goto F_histo;
F_blockedWith:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_975;
  goto GC_COLLECT;
}
  GC_RET_975:
atom = getPTR(L_sp[-1])[3];
getPTR(L_sp[-1])[3] = makeINT(0);
eval_ret_addr = &&LABEL_976;
goto EVAL;
LABEL_976:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_blockedWith___0);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = makeHDR(3);
hp[4] = makeFUN(&&F_union);
hp[5] = getPTR(L_sp[-2])[2];
hp[6] = makePTR(hp+0);
hp[7] = makeHDR(3);
hp[8] = makeFUN(&&F_filterEks);
hp[9] = makePTR(hp+3);
hp[10] = getPTR(L_sp[-1])[3];
hp[11] = makeHDR(3);
hp[12] = makeFUN(&&F_filterNonEks);
hp[13] = makePTR(hp+3);
hp[14] = getPTR(L_sp[-1])[3];
hp[15] = makeHDR(3);
hp[16] = makeFUN(&&F_blockedWith);
hp[17] = makePTR(hp+3);
hp[18] = makePTR(hp+11);
hp[19] = makeHDR(3);
hp[20] = makeFUN(&&F_append);
hp[21] = makePTR(hp+7);
hp[22] = makePTR(hp+15);
hp[23] = makeHDR(3);
hp[24] = makeCTR(C_Cons);
hp[25] = getPTR(L_sp[-1])[2];
hp[26] = makePTR(hp+19);
atom = makePTR(hp+23);
hp += 27;
L_POP(2);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
}
F_blockedWith___0:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_982;
  goto GC_COLLECT;
}
  GC_RET_982:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_983;
goto EVAL;
LABEL_983:
switch (res) {
case C_K:
hp[0] = makeHDR(3);
hp[1] = makeCTR(C_Cons);
hp[2] = getPTR(L_sp[-1])[4];
hp[3] = makeCTR(C_Nil);
hp[4] = makeHDR(3);
hp[5] = makeCTR(C_Cons);
hp[6] = getPTR(L_sp[-1])[3];
hp[7] = makePTR(hp+0);
atom = makePTR(hp+4);
hp += 8;
L_POP(2);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
}
F_endsSubset:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_985;
  goto GC_COLLECT;
}
  GC_RET_985:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_endsSubset___0);
hp[2] = getPTR(L_sp[-1])[3];
hp[3] = makeHDR(3);
hp[4] = makeFUN(&&F_subset);
hp[5] = makePTR(hp+0);
hp[6] = getPTR(L_sp[-1])[2];
atom = makePTR(hp+3);
hp += 7;
L_POP(1);
L_PUSH(atom);
goto F_subset;
F_endsSubset___0:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_987;
  goto GC_COLLECT;
}
  GC_RET_987:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_988;
goto EVAL;
LABEL_988:
switch (res) {
case C_K:
hp[0] = makeHDR(3);
hp[1] = makeCTR(C_Cons);
hp[2] = getPTR(L_sp[-1])[4];
hp[3] = makeCTR(C_Nil);
hp[4] = makeHDR(3);
hp[5] = makeCTR(C_Cons);
hp[6] = getPTR(L_sp[-1])[3];
hp[7] = makePTR(hp+0);
atom = makePTR(hp+4);
hp += 8;
L_POP(2);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
}
F_enKey:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_990;
  goto GC_COLLECT;
}
  GC_RET_990:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_enKey___0);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = makeHDR(2);
hp[4] = makeFUN(&&F_last);
hp[5] = getPTR(L_sp[-1])[2];
hp[6] = makeHDR(3);
hp[7] = makeFUN(&&F_lengthAcc);
hp[8] = makeINT(0);
hp[9] = getPTR(L_sp[-1])[2];
hp[10] = makeHDR(5);
hp[11] = makeCTR(C_K);
hp[12] = getPTR(L_sp[-1])[2];
hp[13] = makePTR(hp+0);
hp[14] = makePTR(hp+3);
hp[15] = makePTR(hp+6);
atom = makePTR(hp+10);
hp += 16;
L_POP(1);
L_PUSH(atom);
res = C_K;
goto EVAL_RET;
F_enKey___0:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_994;
  goto GC_COLLECT;
}
  GC_RET_994:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_995;
goto EVAL;
LABEL_995:
switch (res) {
case C_Cons:
atom = getPTR(L_sp[-1])[2];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_hashAssoc:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_996;
  goto GC_COLLECT;
}
  GC_RET_996:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_997;
goto EVAL;
LABEL_997:
switch (res) {
case C_Hash:
atom = getPTR(L_sp[-1])[3];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_findhash:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_998;
  goto GC_COLLECT;
}
  GC_RET_998:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_lengthAcc);
hp[2] = makeINT(0);
hp[3] = getPTR(L_sp[-1])[3];
hp[4] = makeHDR(4);
hp[5] = makeCTR(C_H);
hp[6] = makeCTR(C_Nothing);
hp[7] = makeCTR(C_Nothing);
hp[8] = makeCTR(C_Nil);
hp[9] = makeHDR(3);
hp[10] = makeCTR(C_Hash);
hp[11] = makePTR(hp+4);
hp[12] = makeCTR(C_Nil);
hp[13] = makeHDR(5);
hp[14] = makeFUN(&&F_hashes);
hp[15] = getPTR(L_sp[-1])[2];
hp[16] = makePTR(hp+0);
hp[17] = getPTR(L_sp[-1])[3];
hp[18] = makePTR(hp+9);
atom = makePTR(hp+13);
hp += 19;
eval_ret_addr = &&LABEL_1002;
goto EVAL;
LABEL_1002:
switch (res) {
case C_Cons:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_1003;
goto EVAL;
LABEL_1003:
switch (res) {
case C_Hash:
hp[0] = makeHDR(2);
hp[1] = makeCTR(C_Just);
hp[2] = getPTR(L_sp[-1])[3];
atom = makePTR(hp+0);
hp += 3;
L_POP(3);
L_PUSH(atom);
res = C_Just;
goto EVAL_RET;
}
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_Nothing));
res = C_Nothing;
goto EVAL_RET;
}
F_hashes:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_1004;
  goto GC_COLLECT;
}
  GC_RET_1004:
atom = getPTR(L_sp[-1])[4];
getPTR(L_sp[-1])[4] = makeINT(0);
eval_ret_addr = &&LABEL_1005;
goto EVAL;
LABEL_1005:
switch (res) {
case C_Nil:
hp[0] = makeHDR(3);
hp[1] = makeCTR(C_Cons);
hp[2] = getPTR(L_sp[-2])[5];
hp[3] = makeCTR(C_Nil);
atom = makePTR(hp+0);
hp += 4;
L_POP(2);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_hashes___0);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = makeHDR(2);
hp[4] = makeFUN(&&F_hashes___1);
hp[5] = getPTR(L_sp[-1])[2];
hp[6] = makeHDR(4);
hp[7] = makeFUN(&&F_assignUpto);
hp[8] = getPTR(L_sp[-2])[2];
hp[9] = makePTR(hp+3);
hp[10] = getPTR(L_sp[-2])[5];
hp[11] = makeHDR(4);
hp[12] = makeFUN(&&F_concatMapAssignUpto);
hp[13] = getPTR(L_sp[-2])[2];
hp[14] = makePTR(hp+0);
hp[15] = makePTR(hp+6);
hp[16] = makeHDR(4);
hp[17] = makeFUN(&&F_concatMapInsertKey);
hp[18] = getPTR(L_sp[-2])[3];
hp[19] = getPTR(L_sp[-1])[2];
hp[20] = makePTR(hp+11);
hp[21] = makeHDR(5);
hp[22] = makeFUN(&&F_concatMapHashes);
hp[23] = getPTR(L_sp[-2])[2];
hp[24] = getPTR(L_sp[-2])[3];
hp[25] = getPTR(L_sp[-1])[3];
hp[26] = makePTR(hp+16);
atom = makePTR(hp+21);
hp += 27;
L_POP(2);
L_PUSH(atom);
goto F_concatMapHashes;
}
F_hashes___0:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_1011;
  goto GC_COLLECT;
}
  GC_RET_1011:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_1012;
goto EVAL;
LABEL_1012:
switch (res) {
case C_K:
atom = getPTR(L_sp[-1])[4];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_hashes___1:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_1013;
  goto GC_COLLECT;
}
  GC_RET_1013:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_1014;
goto EVAL;
LABEL_1014:
switch (res) {
case C_K:
atom = getPTR(L_sp[-1])[3];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_assignUpto:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_1015;
  goto GC_COLLECT;
}
  GC_RET_1015:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_assignUpto___0);
hp[2] = getPTR(L_sp[-1])[4];
hp[3] = makeHDR(3);
hp[4] = makeFUN(&&F_assocm);
hp[5] = getPTR(L_sp[-1])[3];
hp[6] = makePTR(hp+0);
atom = makePTR(hp+3);
hp += 7;
eval_ret_addr = &&LABEL_1017;
goto EVAL;
LABEL_1017:
switch (res) {
case C_Nothing:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_enumFromTo);
hp[2] = makeINT(0);
hp[3] = getPTR(L_sp[-2])[2];
hp[4] = makeHDR(4);
hp[5] = makeFUN(&&F_mapAssign);
hp[6] = getPTR(L_sp[-2])[3];
hp[7] = getPTR(L_sp[-2])[4];
hp[8] = makePTR(hp+0);
atom = makePTR(hp+4);
hp += 9;
L_POP(2);
L_PUSH(atom);
goto F_mapAssign;
case C_Just:
hp[0] = makeHDR(3);
hp[1] = makeCTR(C_Cons);
hp[2] = getPTR(L_sp[-2])[4];
hp[3] = makeCTR(C_Nil);
atom = makePTR(hp+0);
hp += 4;
L_POP(2);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
}
F_assignUpto___0:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_1019;
  goto GC_COLLECT;
}
  GC_RET_1019:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_1020;
goto EVAL;
LABEL_1020:
switch (res) {
case C_Hash:
atom = getPTR(L_sp[-1])[3];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_insertKey:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_1021;
  goto GC_COLLECT;
}
  GC_RET_1021:
atom = getPTR(L_sp[-1])[4];
getPTR(L_sp[-1])[4] = makeINT(0);
eval_ret_addr = &&LABEL_1022;
goto EVAL;
LABEL_1022:
switch (res) {
case C_Hash:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_hash);
hp[2] = getPTR(L_sp[-1])[3];
hp[3] = getPTR(L_sp[-2])[3];
hp[4] = makeHDR(4);
hp[5] = makeFUN(&&F_hinsert);
hp[6] = getPTR(L_sp[-2])[2];
hp[7] = makePTR(hp+0);
hp[8] = getPTR(L_sp[-1])[2];
atom = makePTR(hp+4);
hp += 9;
eval_ret_addr = &&LABEL_1024;
goto EVAL;
LABEL_1024:
switch (res) {
case C_Nothing:
L_POP(3);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
case C_Just:
hp[0] = makeHDR(3);
hp[1] = makeCTR(C_Hash);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = getPTR(L_sp[-2])[3];
hp[4] = makeHDR(3);
hp[5] = makeCTR(C_Cons);
hp[6] = makePTR(hp+0);
hp[7] = makeCTR(C_Nil);
atom = makePTR(hp+4);
hp += 8;
L_POP(3);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
}
}
F_assign:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_1026;
  goto GC_COLLECT;
}
  GC_RET_1026:
atom = getPTR(L_sp[-1])[3];
getPTR(L_sp[-1])[3] = makeINT(0);
eval_ret_addr = &&LABEL_1027;
goto EVAL;
LABEL_1027:
switch (res) {
case C_Hash:
hp[0] = makeHDR(3);
hp[1] = makeCTR(C_Pair);
hp[2] = getPTR(L_sp[-2])[2];
hp[3] = getPTR(L_sp[-2])[4];
hp[4] = makeHDR(3);
hp[5] = makeCTR(C_Cons);
hp[6] = makePTR(hp+0);
hp[7] = getPTR(L_sp[-1])[3];
hp[8] = makeHDR(3);
hp[9] = makeCTR(C_Hash);
hp[10] = getPTR(L_sp[-1])[2];
hp[11] = makePTR(hp+4);
atom = makePTR(hp+8);
hp += 12;
L_POP(2);
L_PUSH(atom);
res = C_Hash;
goto EVAL_RET;
}
F_getlo:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_1030;
  goto GC_COLLECT;
}
  GC_RET_1030:
atom = getPTR(L_sp[-1])[3];
getPTR(L_sp[-1])[3] = makeINT(0);
eval_ret_addr = &&LABEL_1031;
goto EVAL;
LABEL_1031:
switch (res) {
case C_Nothing:
atom = getPTR(L_sp[-2])[2];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
case C_Just:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_min);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = getPTR(L_sp[-2])[2];
atom = makePTR(hp+0);
hp += 4;
L_POP(2);
L_PUSH(atom);
goto F_min;
}
F_gethi:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_1032;
  goto GC_COLLECT;
}
  GC_RET_1032:
atom = getPTR(L_sp[-1])[3];
getPTR(L_sp[-1])[3] = makeINT(0);
eval_ret_addr = &&LABEL_1033;
goto EVAL;
LABEL_1033:
switch (res) {
case C_Nothing:
atom = getPTR(L_sp[-2])[2];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
case C_Just:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_max);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = getPTR(L_sp[-2])[2];
atom = makePTR(hp+0);
hp += 4;
L_POP(2);
L_PUSH(atom);
goto F_max;
}
F_hinsert:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_1034;
  goto GC_COLLECT;
}
  GC_RET_1034:
atom = getPTR(L_sp[-1])[4];
getPTR(L_sp[-1])[4] = makeINT(0);
eval_ret_addr = &&LABEL_1035;
goto EVAL;
LABEL_1035:
switch (res) {
case C_H:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_getlo);
hp[2] = getPTR(L_sp[-2])[3];
hp[3] = getPTR(L_sp[-1])[2];
hp[4] = makeHDR(3);
hp[5] = makeFUN(&&F_gethi);
hp[6] = getPTR(L_sp[-2])[3];
hp[7] = getPTR(L_sp[-1])[3];
hp[8] = makeHDR(6);
hp[9] = makeFUN(&&F_hinsert___0);
hp[10] = getPTR(L_sp[-2])[3];
hp[11] = getPTR(L_sp[-1])[4];
hp[12] = makePTR(hp+4);
hp[13] = makePTR(hp+0);
hp[14] = getPTR(L_sp[-2])[2];
atom = makePTR(hp+8);
hp += 15;
L_POP(2);
L_PUSH(atom);
goto F_hinsert___0;
}
F_hinsert___0:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_1036;
  goto GC_COLLECT;
}
  GC_RET_1036:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_elem);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = getPTR(L_sp[-1])[3];
atom = makePTR(hp+0);
hp += 4;
eval_ret_addr = &&LABEL_1037;
goto EVAL;
LABEL_1037:
switch (res) {
case C_True:
L_POP(2);
L_PUSH(makeCTR(C_Nothing));
res = C_Nothing;
goto EVAL_RET;
case C_False:
L_PUSH(makeINT(1));
res = 1;
atom = getPTR(L_sp[-3])[4];
eval_ret_addr = &&LABEL_1038;
goto EVAL;
LABEL_1038:
L_POP(1);
res = getINT(L_top) + res;
L_POP(1);
L_PUSH(makeINT(res));
atom = getPTR(L_sp[-3])[5];
eval_ret_addr = &&LABEL_1039;
goto EVAL;
LABEL_1039:
L_POP(1);
res = getINT(L_top) - res;
L_POP(1);
L_PUSH(makeINT(res));
atom = getPTR(L_sp[-3])[6];
eval_ret_addr = &&LABEL_1040;
goto EVAL;
LABEL_1040:
L_POP(1);
res = getINT(L_top) <= res ? C_True : C_False;
L_POP(1);
L_PUSH(makeCTR(res));
switch (res) {
case C_False:
L_POP(3);
L_PUSH(makeCTR(C_Nothing));
res = C_Nothing;
goto EVAL_RET;
case C_True:
hp[0] = makeHDR(2);
hp[1] = makeCTR(C_Just);
hp[2] = getPTR(L_sp[-3])[5];
hp[3] = makeHDR(2);
hp[4] = makeCTR(C_Just);
hp[5] = getPTR(L_sp[-3])[4];
hp[6] = makeHDR(3);
hp[7] = makeCTR(C_Cons);
hp[8] = getPTR(L_sp[-3])[2];
hp[9] = getPTR(L_sp[-3])[3];
hp[10] = makeHDR(4);
hp[11] = makeCTR(C_H);
hp[12] = makePTR(hp+0);
hp[13] = makePTR(hp+3);
hp[14] = makePTR(hp+6);
hp[15] = makeHDR(2);
hp[16] = makeCTR(C_Just);
hp[17] = makePTR(hp+10);
atom = makePTR(hp+15);
hp += 18;
L_POP(3);
L_PUSH(atom);
res = C_Just;
goto EVAL_RET;
}
}
F_hash:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_1045;
  goto GC_COLLECT;
}
  GC_RET_1045:
atom = getPTR(L_sp[-1])[3];
getPTR(L_sp[-1])[3] = makeINT(0);
eval_ret_addr = &&LABEL_1046;
goto EVAL;
LABEL_1046:
switch (res) {
case C_K:
atom = getPTR(L_sp[-1])[5];
eval_ret_addr = &&LABEL_1047;
goto EVAL;
LABEL_1047:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_assoc);
hp[2] = getPTR(L_sp[-2])[3];
hp[3] = getPTR(L_sp[-3])[2];
atom = makePTR(hp+0);
hp += 4;
eval_ret_addr = &&LABEL_1048;
goto EVAL;
LABEL_1048:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_assoc);
hp[2] = getPTR(L_sp[-3])[4];
hp[3] = getPTR(L_sp[-4])[2];
atom = makePTR(hp+0);
hp += 4;
eval_ret_addr = &&LABEL_1049;
goto EVAL;
LABEL_1049:
L_POP(1);
res = getINT(L_top) + res;
L_POP(1);
L_PUSH(makeINT(res));
L_POP(1);
res = getINT(L_top) + res;
L_POP(3);
L_PUSH(makeINT(res));
goto EVAL_RET;
}
F_cichelli:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_1050;
  goto GC_COLLECT;
}
  GC_RET_1050:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_mapEnKey);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = makeHDR(2);
hp[4] = makeFUN(&&F_freqSorted);
hp[5] = makePTR(hp+0);
atom = makePTR(hp+3);
hp += 6;
eval_ret_addr = &&LABEL_1052;
goto EVAL;
LABEL_1052:
switch (res) {
case C_Pair:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_blockedWith);
hp[2] = makeCTR(C_Nil);
hp[3] = getPTR(L_sp[-1])[2];
hp[4] = makeHDR(3);
hp[5] = makeFUN(&&F_findhash);
hp[6] = getPTR(L_sp[-1])[3];
hp[7] = makePTR(hp+0);
atom = makePTR(hp+4);
hp += 8;
L_POP(2);
L_PUSH(atom);
goto F_findhash;
}
F_emitHashFun:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_1054;
  goto GC_COLLECT;
}
  GC_RET_1054:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_1055;
goto EVAL;
LABEL_1055:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeINT(0));
res = 0;
goto EVAL_RET;
case C_Cons:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_1056;
goto EVAL;
LABEL_1056:
switch (res) {
case C_Pair:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_1057;
goto EVAL;
LABEL_1057:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_1058;
goto EVAL;
LABEL_1058:
L_POP(1);
res = getINT(L_top) + res;
L_POP(1);
L_PUSH(makeINT(res));
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_emitHashFun);
hp[2] = getPTR(L_sp[-3])[3];
atom = makePTR(hp+0);
hp += 3;
eval_ret_addr = &&LABEL_1059;
goto EVAL;
LABEL_1059:
L_POP(1);
res = getINT(L_top) + res;
L_POP(4);
L_PUSH(makeINT(res));
goto EVAL_RET;
}
}
P_ADD:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_1060;
  goto GC_COLLECT;
}
  GC_RET_1060:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_1061;
goto EVAL;
LABEL_1061:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_1062;
goto EVAL;
LABEL_1062:
L_POP(1);
res = getINT(L_top) + res;
L_POP(2);
L_PUSH(makeINT(res));
goto EVAL_RET;
P_SUB:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_1063;
  goto GC_COLLECT;
}
  GC_RET_1063:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_1064;
goto EVAL;
LABEL_1064:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_1065;
goto EVAL;
LABEL_1065:
L_POP(1);
res = getINT(L_top) - res;
L_POP(2);
L_PUSH(makeINT(res));
goto EVAL_RET;
P_EQ:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_1066;
  goto GC_COLLECT;
}
  GC_RET_1066:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_1067;
goto EVAL;
LABEL_1067:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_1068;
goto EVAL;
LABEL_1068:
L_POP(1);
res = getINT(L_top) == res ? C_True : C_False;
L_POP(2);
L_PUSH(makeCTR(res));
goto EVAL_RET;
P_NEQ:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_1069;
  goto GC_COLLECT;
}
  GC_RET_1069:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_1070;
goto EVAL;
LABEL_1070:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_1071;
goto EVAL;
LABEL_1071:
L_POP(1);
res = getINT(L_top) != res ? C_True : C_False;
L_POP(2);
L_PUSH(makeCTR(res));
goto EVAL_RET;
P_LEQ:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_1072;
  goto GC_COLLECT;
}
  GC_RET_1072:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_1073;
goto EVAL;
LABEL_1073:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_1074;
goto EVAL;
LABEL_1074:
L_POP(1);
res = getINT(L_top) <= res ? C_True : C_False;
L_POP(2);
L_PUSH(makeCTR(res));
goto EVAL_RET;
GC_COPY:
if (from[0] == VISITED) {
  atom = from[1];
  goto *gc_copy_ret;
}
if (isPTR(from[1])) { from = getPTR(from[1]); goto GC_COPY; }
if (size(from[0]) == 1) { atom = from[1]; }
else {
  n = size(from[0]) + 1;
  //printf("Copy (%i);\n", n-1);
  atom = makePTR(free);
  for (i = 0; i < n; i++)
    { *free = from[i]; free++; }
  from[0] = VISITED;
  from[1] = atom;
}
goto *gc_copy_ret;
GC_COLLECT:
//printf("GC invoked (%i);\n", hp - fromSpace);
scan = toSpace;
free = toSpace;
for (p = L_base; p < L_sp; p++) {
  if (isPTR(*p)) {
    from = getPTR(*p);
    gc_copy_ret = &&GC_COPY_RET1; goto GC_COPY; GC_COPY_RET1:
    *p = atom;
  }
}
while (scan < free) {
  m = size(*scan); scan++;
  //printf("Scan (%i);\n", m);
  for (j = 0; j < m; j++) {
    if (isPTR(*scan)) {
      from = getPTR(*scan);
      gc_copy_ret = &&GC_COPY_RET2; goto GC_COPY; GC_COPY_RET2:
      *scan = atom;
    }
    scan++;
  }
}
for (frame = R_base; frame > R_sp; frame--) {
  p = frame->current;
  frame->current = 0;
  while (p && p[0] != VISITED && isPTR(p[1])) p = getPTR(p[1]);
  if (p && p[0] == VISITED) {
    if (isPTR(p[1])) frame->current = getPTR(p[1]);
  }
}
hp = free;
p = fromSpace; fromSpace = toSpace; toSpace = p;
p = fromSpaceEnd; fromSpaceEnd = toSpaceEnd; toSpaceEnd = p;
heapEnd = fromSpaceEnd;
L_top = L_sp[-1];
R_top_returnAddress = R_sp[1].returnAddress;
R_top_current = R_sp[1].current;
//printf("GC finished (%i);\n", hp - fromSpace);
goto *gc_ret;
}



