#include <stdio.h>
#include <stdlib.h>
typedef unsigned int Atom;
#define isPTR(a)   (((a)&3) == 0)
#define isCTR(a)   (((a)&3) == 1)
#define isINT(a)   (((a)&3) == 2)
#define isFUN(a)   (((a)&3) == 3)
#define getPTR(a)  ((Atom*) (a))
#define getCTR(a)  ((a) >> 2)
#define getINT(a)  ((int) (((int) (a)) >> 2))
#define getFUN(a)  ((void*) (((unsigned int) (a)) & (~3)))
#define makePTR(x) ((Atom) (x))
#define makeCTR(x) ((Atom) (((x) << 2) | 1))
#define makeINT(x) ((Atom) ((((unsigned int) (x)) << 2) | 2))
#define makeFUN(x) ((Atom) (((unsigned int) (x)) | 3))
#define HEAP_SIZE 22000
#define STACK_SIZE 3000
typedef struct {
  Atom* current;
  void* returnAddress;
} Frame;
#define L_POP(n) L_sp-=n; L_top = L_sp[-1];
#define L_PUSH(a) L_top = a; L_sp[0] = L_top; L_sp++;
#define R_POP \
  R_sp++;\
  R_top_returnAddress = R_sp[1].returnAddress;\
  R_top_current = R_sp[1].current;
#define R_PUSH(ra, cur) \
  R_top_returnAddress = R_sp[0].returnAddress = ra; \
  R_top_current = R_sp[0].current = cur; \
  R_sp--;
#define makeHDR(x)        ((x) << 1)
#define VISITED           1
#define size(x)           ((x) >> 1)
#define C_False 0
#define C_True 1
#define C_Cons 0
#define C_Nil 1


int main() {
register Atom* L_sp;
Atom* L_base;
register Atom L_top;
register Frame* R_sp;
Frame* R_base;
register void* R_top_returnAddress;
register Atom* R_top_current;
register Atom* hp;
register Atom* heapEnd;
register Atom atom;
register Atom* app;
register int res;
Atom* fromSpace;
Atom* toSpace;
Atom* fromSpaceEnd;
Atom* toSpaceEnd;
Atom* scan;
Atom* free;
Atom* p;
Atom* from;
Frame* frame;
void* gc_copy_ret;
void* gc_ret;
void* eval_ret_addr;
int i;
int j;
int n;
int m;
L_base = L_sp = malloc(sizeof(Atom) * STACK_SIZE);
R_base = R_sp = (Frame*) &L_sp[STACK_SIZE-1];
fromSpace = hp = malloc(sizeof(Atom) * HEAP_SIZE);
heapEnd = fromSpaceEnd = &fromSpace[HEAP_SIZE-1000];
toSpace = malloc(sizeof(Atom) * HEAP_SIZE);
toSpaceEnd = &toSpace[HEAP_SIZE-1000];
print("S");
atom = makePTR(hp);
*hp++ = makeHDR(1); *hp++ =  makeFUN(&&F_main);
L_PUSH(atom);
eval_ret_addr = &&LABEL_71;
goto EVAL;
LABEL_71:
putnum(getINT(L_top));
return 0;
EVAL:
if (isPTR(atom)) {
  app = getPTR(atom);
  EVAL_APP:
  if (isFUN(app[1])) {
    L_PUSH(makePTR(app));
    R_PUSH(eval_ret_addr, app);
    goto *getFUN(app[1]);
    EVAL_RET:
    if (R_top_current) {
      R_top_current[0] = makeHDR(1);
      R_top_current[1] = L_top;
    }
    eval_ret_addr = R_top_returnAddress;
    R_POP;
    goto *eval_ret_addr;
  }
  else if (isCTR(app[1])) {
    L_PUSH(makePTR(app)); res = getCTR(app[1]);
    goto *eval_ret_addr;
  }
  else if (isPTR(app[1])) {
    app = getPTR(app[1]);
    goto EVAL_APP;
  }
  else {
    L_PUSH(app[1]); res = getINT(app[1]);
    goto *eval_ret_addr;
  }
} else {
  L_PUSH(atom);
  res = getINT(atom);
  goto *eval_ret_addr;
}
TAIL_EVAL:
if (isPTR(atom)) {
  app = getPTR(atom);
  TAIL_EVAL_APP:
  if (isFUN(app[1])) {
    L_PUSH(makePTR(app));
    if (R_top_current) {
      R_top_current[0] = makeHDR(1);
      R_top_current[1] = makePTR(app);
    }
    R_top_current = R_sp[1].current = app;
    goto *getFUN(app[1]);
  }
  else if (isPTR(app[1])) {
    app = getPTR(app[1]);
    goto TAIL_EVAL_APP;
  }
  else if (isINT(app[1])) {
    L_PUSH(app[1]); res = getINT(app[1]);
    goto EVAL_RET;
  }
  else {
    L_PUSH(makePTR(app)); res = getCTR(app[1]);
    goto EVAL_RET;
  }
} else {
  L_PUSH(atom);
  res = getINT(atom);
  goto EVAL_RET;
}
F_toOne_V_:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_72;
  goto GC_COLLECT;
}
  GC_RET_72:
res = getINT(getPTR(L_sp[-1])[2])==1? C_True : C_False;
L_PUSH(makeCTR(res));
switch (res) {
case C_True:
hp[0] = makeHDR(3);
hp[1] = makeCTR(C_Cons);
hp[2] = makeINT(1);
hp[3] = makeCTR(C_Nil);
atom = makePTR(hp+0);
hp += 4;
L_POP(2);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
case C_False:
hp[0] = makeINT(getINT(getPTR(L_sp[-2])[2])-1);
hp[1] = makeHDR(2);
hp[2] = makeFUN(&&F_toOne_V_);
hp[3] = hp[0];
hp[4] = makeHDR(3);
hp[5] = makeCTR(C_Cons);
hp[6] = getPTR(L_sp[-2])[2];
hp[7] = makePTR(hp+1);
atom = makePTR(hp+4);
hp += 8;
L_POP(2);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
}
F_safe_V__V__V_:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_75;
  goto GC_COLLECT;
}
  GC_RET_75:
atom = getPTR(L_sp[-1])[4];
getPTR(L_sp[-1])[4] = makeINT(0);
eval_ret_addr = &&LABEL_76;
goto EVAL;
LABEL_76:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_True));
res = C_True;
goto EVAL_RET;
case C_Cons:
res = getINT(getPTR(L_sp[-2])[2])!=getINT(getPTR(L_sp[-1])[2])? C_True : C_False;
L_PUSH(makeCTR(res));
switch (res) {
case C_False:
L_POP(3);
L_PUSH(makeCTR(C_False));
res = C_False;
goto EVAL_RET;
case C_True:
res = getINT(getPTR(L_sp[-3])[2])!=getINT(getPTR(L_sp[-2])[2])+getINT(getPTR(L_sp[-3])[3])? C_True : C_False;
L_PUSH(makeCTR(res));
switch (res) {
case C_False:
L_POP(4);
L_PUSH(makeCTR(C_False));
res = C_False;
goto EVAL_RET;
case C_True:
res = getINT(getPTR(L_sp[-4])[2])!=getINT(getPTR(L_sp[-3])[2])-getINT(getPTR(L_sp[-4])[3])? C_True : C_False;
L_PUSH(makeCTR(res));
switch (res) {
case C_False:
L_POP(5);
L_PUSH(makeCTR(C_False));
res = C_False;
goto EVAL_RET;
case C_True:
hp[0] = makeINT(getINT(getPTR(L_sp[-5])[3])+1);
hp[1] = makeHDR(4);
hp[2] = makeFUN(&&F_safe_V__V__V_);
hp[3] = getPTR(L_sp[-5])[2];
hp[4] = hp[0];
hp[5] = getPTR(L_sp[-4])[3];
atom = makePTR(hp+1);
hp += 6;
L_POP(5);
L_PUSH(atom);
goto F_safe_V__V__V_;
}
}
}
}
F_gen2_V__V_:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_78;
  goto GC_COLLECT;
}
  GC_RET_78:
hp[0] = makeHDR(4);
hp[1] = makeFUN(&&F_safe_V__V__V_);
hp[2] = getPTR(L_sp[-1])[3];
hp[3] = makeINT(1);
hp[4] = getPTR(L_sp[-1])[2];
atom = makePTR(hp+0);
hp += 5;
eval_ret_addr = &&LABEL_79;
goto EVAL;
LABEL_79:
switch (res) {
case C_True:
hp[0] = makeHDR(3);
hp[1] = makeCTR(C_Cons);
hp[2] = getPTR(L_sp[-2])[3];
hp[3] = getPTR(L_sp[-2])[2];
hp[4] = makeHDR(3);
hp[5] = makeCTR(C_Cons);
hp[6] = makePTR(hp+0);
hp[7] = makeCTR(C_Nil);
atom = makePTR(hp+4);
hp += 8;
L_POP(2);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
case C_False:
L_POP(2);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
}
F_concatMapGen2_V__V_:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_81;
  goto GC_COLLECT;
}
  GC_RET_81:
atom = getPTR(L_sp[-1])[3];
getPTR(L_sp[-1])[3] = makeINT(0);
eval_ret_addr = &&LABEL_82;
goto EVAL;
LABEL_82:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_gen2_V__V_);
hp[2] = getPTR(L_sp[-2])[2];
hp[3] = getPTR(L_sp[-1])[2];
hp[4] = makeHDR(3);
hp[5] = makeFUN(&&F_concatMapGen2_V__V_);
hp[6] = getPTR(L_sp[-2])[2];
hp[7] = getPTR(L_sp[-1])[3];
hp[8] = makeHDR(3);
hp[9] = makeFUN(&&F_append_V__V_);
hp[10] = makePTR(hp+0);
hp[11] = makePTR(hp+4);
atom = makePTR(hp+8);
hp += 12;
L_POP(2);
L_PUSH(atom);
goto F_append_V__V_;
}
F_append_V__V_:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_85;
  goto GC_COLLECT;
}
  GC_RET_85:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_86;
goto EVAL;
LABEL_86:
switch (res) {
case C_Nil:
atom = getPTR(L_sp[-2])[3];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_append_V__V_);
hp[2] = getPTR(L_sp[-1])[3];
hp[3] = getPTR(L_sp[-2])[3];
hp[4] = makeHDR(3);
hp[5] = makeCTR(C_Cons);
hp[6] = getPTR(L_sp[-1])[2];
hp[7] = makePTR(hp+0);
atom = makePTR(hp+4);
hp += 8;
L_POP(2);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
}
F_concatMapGen1_V__V_:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_88;
  goto GC_COLLECT;
}
  GC_RET_88:
atom = getPTR(L_sp[-1])[3];
getPTR(L_sp[-1])[3] = makeINT(0);
eval_ret_addr = &&LABEL_89;
goto EVAL;
LABEL_89:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_toOne_V_);
hp[2] = getPTR(L_sp[-2])[2];
hp[3] = makeHDR(3);
hp[4] = makeFUN(&&F_concatMapGen2_V__V_);
hp[5] = getPTR(L_sp[-1])[2];
hp[6] = makePTR(hp+0);
hp[7] = makeHDR(3);
hp[8] = makeFUN(&&F_concatMapGen1_V__V_);
hp[9] = getPTR(L_sp[-2])[2];
hp[10] = getPTR(L_sp[-1])[3];
hp[11] = makeHDR(3);
hp[12] = makeFUN(&&F_append_V__V_);
hp[13] = makePTR(hp+3);
hp[14] = makePTR(hp+7);
atom = makePTR(hp+11);
hp += 15;
L_POP(2);
L_PUSH(atom);
goto F_append_V__V_;
}
F_gen_V__V_:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_93;
  goto GC_COLLECT;
}
  GC_RET_93:
res = getINT(getPTR(L_sp[-1])[3])==0? C_True : C_False;
L_PUSH(makeCTR(res));
switch (res) {
case C_True:
hp[0] = makeHDR(3);
hp[1] = makeCTR(C_Cons);
hp[2] = makeCTR(C_Nil);
hp[3] = makeCTR(C_Nil);
atom = makePTR(hp+0);
hp += 4;
L_POP(2);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
case C_False:
hp[0] = makeINT(getINT(getPTR(L_sp[-2])[3])-1);
hp[1] = makeHDR(3);
hp[2] = makeFUN(&&F_gen_V__V_);
hp[3] = getPTR(L_sp[-2])[2];
hp[4] = hp[0];
hp[5] = makeHDR(3);
hp[6] = makeFUN(&&F_concatMapGen1_V__V_);
hp[7] = getPTR(L_sp[-2])[2];
hp[8] = makePTR(hp+1);
atom = makePTR(hp+5);
hp += 9;
L_POP(2);
L_PUSH(atom);
goto F_concatMapGen1_V__V_;
}
F_lengthAcc_V__V_:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_96;
  goto GC_COLLECT;
}
  GC_RET_96:
atom = getPTR(L_sp[-1])[3];
getPTR(L_sp[-1])[3] = makeINT(0);
eval_ret_addr = &&LABEL_97;
goto EVAL;
LABEL_97:
switch (res) {
case C_Nil:
atom = getPTR(L_sp[-2])[2];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
case C_Cons:
hp[0] = makeINT(1+getINT(getPTR(L_sp[-2])[2]));
hp[1] = makeHDR(3);
hp[2] = makeFUN(&&F_lengthAcc_V__V_);
hp[3] = hp[0];
hp[4] = getPTR(L_sp[-1])[3];
atom = makePTR(hp+1);
hp += 5;
L_POP(2);
L_PUSH(atom);
goto F_lengthAcc_V__V_;
}
F_nsoln_V_:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_99;
  goto GC_COLLECT;
}
  GC_RET_99:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_gen_V__V_);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = getPTR(L_sp[-1])[2];
hp[4] = makeHDR(3);
hp[5] = makeFUN(&&F_lengthAcc_V__V_);
hp[6] = makeINT(0);
hp[7] = makePTR(hp+0);
atom = makePTR(hp+4);
hp += 8;
L_POP(1);
L_PUSH(atom);
goto F_lengthAcc_V__V_;
F_main:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_101;
  goto GC_COLLECT;
}
  GC_RET_101:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_nsoln_V_);
hp[2] = makeINT(11);
atom = makePTR(hp+0);
hp += 3;
L_POP(1);
L_PUSH(atom);
goto F_nsoln_V_;
P_ADD:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_102;
  goto GC_COLLECT;
}
  GC_RET_102:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_103;
goto EVAL;
LABEL_103:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_104;
goto EVAL;
LABEL_104:
L_POP(1);
res = getINT(L_top) + res;
L_POP(2);
L_PUSH(makeINT(res));
goto EVAL_RET;
P_SUB:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_105;
  goto GC_COLLECT;
}
  GC_RET_105:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_106;
goto EVAL;
LABEL_106:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_107;
goto EVAL;
LABEL_107:
L_POP(1);
res = getINT(L_top) - res;
L_POP(2);
L_PUSH(makeINT(res));
goto EVAL_RET;
P_EQ:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_108;
  goto GC_COLLECT;
}
  GC_RET_108:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_109;
goto EVAL;
LABEL_109:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_110;
goto EVAL;
LABEL_110:
L_POP(1);
res = getINT(L_top) == res ? C_True : C_False;
L_POP(2);
L_PUSH(makeCTR(res));
goto EVAL_RET;
P_NEQ:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_111;
  goto GC_COLLECT;
}
  GC_RET_111:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_112;
goto EVAL;
LABEL_112:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_113;
goto EVAL;
LABEL_113:
L_POP(1);
res = getINT(L_top) != res ? C_True : C_False;
L_POP(2);
L_PUSH(makeCTR(res));
goto EVAL_RET;
P_LEQ:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_114;
  goto GC_COLLECT;
}
  GC_RET_114:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_115;
goto EVAL;
LABEL_115:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_116;
goto EVAL;
LABEL_116:
L_POP(1);
res = getINT(L_top) <= res ? C_True : C_False;
L_POP(2);
L_PUSH(makeCTR(res));
goto EVAL_RET;
GC_COPY:
if (from[0] == VISITED) {
  atom = from[1];
  goto *gc_copy_ret;
}
if (isPTR(from[1])) { from = getPTR(from[1]); goto GC_COPY; }
if (size(from[0]) == 1) { atom = from[1]; }
else {
  n = size(from[0]) + 1;
  //printf("Copy (%i);\n", n-1);
  atom = makePTR(free);
  for (i = 0; i < n; i++)
    { *free = from[i]; free++; }
  from[0] = VISITED;
  from[1] = atom;
}
goto *gc_copy_ret;
GC_COLLECT:
//printf("GC invoked (%i);\n", hp - fromSpace);
scan = toSpace;
free = toSpace;
for (p = L_base; p < L_sp; p++) {
  if (isPTR(*p)) {
    from = getPTR(*p);
    gc_copy_ret = &&GC_COPY_RET1; goto GC_COPY; GC_COPY_RET1:
    *p = atom;
  }
}
while (scan < free) {
  m = size(*scan); scan++;
  //printf("Scan (%i);\n", m);
  for (j = 0; j < m; j++) {
    if (isPTR(*scan)) {
      from = getPTR(*scan);
      gc_copy_ret = &&GC_COPY_RET2; goto GC_COPY; GC_COPY_RET2:
      *scan = atom;
    }
    scan++;
  }
}
for (frame = R_base; frame > R_sp; frame--) {
  p = frame->current;
  frame->current = 0;
  while (p && p[0] != VISITED && isPTR(p[1])) p = getPTR(p[1]);
  if (p && p[0] == VISITED) {
    if (isPTR(p[1])) frame->current = getPTR(p[1]);
  }
}
hp = free;
p = fromSpace; fromSpace = toSpace; toSpace = p;
p = fromSpaceEnd; fromSpaceEnd = toSpaceEnd; toSpaceEnd = p;
heapEnd = fromSpaceEnd;
L_top = L_sp[-1];
R_top_returnAddress = R_sp[1].returnAddress;
R_top_current = R_sp[1].current;
//printf("GC finished (%i);\n", hp - fromSpace);
goto *gc_ret;
}



