#include <stdio.h>
#include <stdlib.h>
typedef unsigned int Atom;
#define isPTR(a)   (((a)&3) == 0)
#define isCTR(a)   (((a)&3) == 1)
#define isINT(a)   (((a)&3) == 2)
#define isFUN(a)   (((a)&3) == 3)
#define getPTR(a)  ((Atom*) (a))
#define getCTR(a)  ((a) >> 2)
#define getINT(a)  ((int) (((int) (a)) >> 2))
#define getFUN(a)  ((void*) (((unsigned int) (a)) & (~3)))
#define makePTR(x) ((Atom) (x))
#define makeCTR(x) ((Atom) (((x) << 2) | 1))
#define makeINT(x) ((Atom) ((((unsigned int) (x)) << 2) | 2))
#define makeFUN(x) ((Atom) (((unsigned int) (x)) | 3))
#define HEAP_SIZE 22000
#define STACK_SIZE 3000
typedef struct {
  Atom* current;
  void* returnAddress;
} Frame;
#define L_POP(n) L_sp-=n; L_top = L_sp[-1];
#define L_PUSH(a) L_top = a; L_sp[0] = L_top; L_sp++;
#define R_POP \
  R_sp++;\
  R_top_returnAddress = R_sp[1].returnAddress;\
  R_top_current = R_sp[1].current;
#define R_PUSH(ra, cur) \
  R_top_returnAddress = R_sp[0].returnAddress = ra; \
  R_top_current = R_sp[0].current = cur; \
  R_sp--;
#define makeHDR(x)        ((x) << 1)
#define VISITED           1
#define size(x)           ((x) >> 1)
#define C_False 0
#define C_True 1
#define C_Pair 0
#define C_Cons 0
#define C_Nil 1
#define C_Just 0
#define C_Nothing 1


int main() {
register Atom* L_sp;
Atom* L_base;
register Atom L_top;
register Frame* R_sp;
Frame* R_base;
register void* R_top_returnAddress;
register Atom* R_top_current;
register Atom* hp;
register Atom* heapEnd;
register Atom atom;
register Atom* app;
register int res;
Atom* fromSpace;
Atom* toSpace;
Atom* fromSpaceEnd;
Atom* toSpaceEnd;
Atom* scan;
Atom* free;
Atom* p;
Atom* from;
Frame* frame;
void* gc_copy_ret;
void* gc_ret;
void* eval_ret_addr;
int i;
int j;
int n;
int m;
L_base = L_sp = malloc(sizeof(Atom) * STACK_SIZE);
R_base = R_sp = (Frame*) &L_sp[STACK_SIZE-1];
fromSpace = hp = malloc(sizeof(Atom) * HEAP_SIZE);
heapEnd = fromSpaceEnd = &fromSpace[HEAP_SIZE-1000];
toSpace = malloc(sizeof(Atom) * HEAP_SIZE);
toSpaceEnd = &toSpace[HEAP_SIZE-1000];
print("S");
atom = makePTR(hp);
*hp++ = makeHDR(1); *hp++ =  makeFUN(&&F_main);
L_PUSH(atom);
eval_ret_addr = &&LABEL_477;
goto EVAL;
LABEL_477:
putnum(getINT(L_top));
return 0;
EVAL:
if (isPTR(atom)) {
  app = getPTR(atom);
  EVAL_APP:
  if (isFUN(app[1])) {
    L_PUSH(makePTR(app));
    R_PUSH(eval_ret_addr, app);
    goto *getFUN(app[1]);
    EVAL_RET:
    if (R_top_current) {
      R_top_current[0] = makeHDR(1);
      R_top_current[1] = L_top;
    }
    eval_ret_addr = R_top_returnAddress;
    R_POP;
    goto *eval_ret_addr;
  }
  else if (isCTR(app[1])) {
    L_PUSH(makePTR(app)); res = getCTR(app[1]);
    goto *eval_ret_addr;
  }
  else if (isPTR(app[1])) {
    app = getPTR(app[1]);
    goto EVAL_APP;
  }
  else {
    L_PUSH(app[1]); res = getINT(app[1]);
    goto *eval_ret_addr;
  }
} else {
  L_PUSH(atom);
  res = getINT(atom);
  goto *eval_ret_addr;
}
TAIL_EVAL:
if (isPTR(atom)) {
  app = getPTR(atom);
  TAIL_EVAL_APP:
  if (isFUN(app[1])) {
    L_PUSH(makePTR(app));
    if (R_top_current) {
      R_top_current[0] = makeHDR(1);
      R_top_current[1] = makePTR(app);
    }
    R_top_current = R_sp[1].current = app;
    goto *getFUN(app[1]);
  }
  else if (isPTR(app[1])) {
    app = getPTR(app[1]);
    goto TAIL_EVAL_APP;
  }
  else if (isINT(app[1])) {
    L_PUSH(app[1]); res = getINT(app[1]);
    goto EVAL_RET;
  }
  else {
    L_PUSH(makePTR(app)); res = getCTR(app[1]);
    goto EVAL_RET;
  }
} else {
  L_PUSH(atom);
  res = getINT(atom);
  goto EVAL_RET;
}
F_main:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_478;
  goto GC_COLLECT;
}
  GC_RET_478:
hp[0] = makeHDR(3);
hp[1] = makeCTR(C_Cons);
hp[2] = makeINT(66);
hp[3] = makeCTR(C_Nil);
hp[4] = makeHDR(3);
hp[5] = makeCTR(C_Cons);
hp[6] = makeINT(65);
hp[7] = makePTR(hp+0);
hp[8] = makeHDR(3);
hp[9] = makeCTR(C_Cons);
hp[10] = makeINT(78);
hp[11] = makePTR(hp+4);
hp[12] = makeHDR(3);
hp[13] = makeCTR(C_Cons);
hp[14] = makeINT(65);
hp[15] = makePTR(hp+8);
hp[16] = makeHDR(3);
hp[17] = makeCTR(C_Cons);
hp[18] = makeINT(78);
hp[19] = makePTR(hp+12);
hp[20] = makeHDR(3);
hp[21] = makeCTR(C_Cons);
hp[22] = makeINT(65);
hp[23] = makePTR(hp+16);
hp[24] = makeHDR(3);
hp[25] = makeCTR(C_Cons);
hp[26] = makeINT(65);
hp[27] = makeCTR(C_Nil);
hp[28] = makeHDR(3);
hp[29] = makeCTR(C_Cons);
hp[30] = makeINT(80);
hp[31] = makePTR(hp+24);
hp[32] = makeHDR(3);
hp[33] = makeCTR(C_Cons);
hp[34] = makeINT(80);
hp[35] = makePTR(hp+28);
hp[36] = makeHDR(3);
hp[37] = makeCTR(C_Cons);
hp[38] = makeINT(76);
hp[39] = makePTR(hp+32);
hp[40] = makeHDR(3);
hp[41] = makeCTR(C_Cons);
hp[42] = makeINT(69);
hp[43] = makePTR(hp+36);
hp[44] = makeHDR(3);
hp[45] = makeCTR(C_Cons);
hp[46] = makeINT(67);
hp[47] = makeCTR(C_Nil);
hp[48] = makeHDR(3);
hp[49] = makeCTR(C_Cons);
hp[50] = makeINT(72);
hp[51] = makePTR(hp+44);
hp[52] = makeHDR(3);
hp[53] = makeCTR(C_Cons);
hp[54] = makeINT(69);
hp[55] = makePTR(hp+48);
hp[56] = makeHDR(3);
hp[57] = makeCTR(C_Cons);
hp[58] = makeINT(82);
hp[59] = makePTR(hp+52);
hp[60] = makeHDR(3);
hp[61] = makeCTR(C_Cons);
hp[62] = makeINT(82);
hp[63] = makePTR(hp+56);
hp[64] = makeHDR(3);
hp[65] = makeCTR(C_Cons);
hp[66] = makeINT(89);
hp[67] = makePTR(hp+60);
hp[68] = makeHDR(3);
hp[69] = makeCTR(C_Cons);
hp[70] = makeINT(80);
hp[71] = makeCTR(C_Nil);
hp[72] = makeHDR(3);
hp[73] = makeCTR(C_Cons);
hp[74] = makeINT(69);
hp[75] = makePTR(hp+68);
hp[76] = makeHDR(3);
hp[77] = makeCTR(C_Cons);
hp[78] = makeINT(65);
hp[79] = makePTR(hp+72);
hp[80] = makeHDR(3);
hp[81] = makeCTR(C_Cons);
hp[82] = makeINT(67);
hp[83] = makePTR(hp+76);
hp[84] = makeHDR(3);
hp[85] = makeCTR(C_Cons);
hp[86] = makeINT(72);
hp[87] = makePTR(hp+80);
hp[88] = makeHDR(3);
hp[89] = makeCTR(C_Cons);
hp[90] = makeINT(65);
hp[91] = makeCTR(C_Nil);
hp[92] = makeHDR(3);
hp[93] = makeCTR(C_Cons);
hp[94] = makeINT(80);
hp[95] = makePTR(hp+88);
hp[96] = makeHDR(3);
hp[97] = makeCTR(C_Cons);
hp[98] = makeINT(82);
hp[99] = makePTR(hp+92);
hp[100] = makeHDR(3);
hp[101] = makeCTR(C_Cons);
hp[102] = makeINT(73);
hp[103] = makePTR(hp+96);
hp[104] = makeHDR(3);
hp[105] = makeCTR(C_Cons);
hp[106] = makeINT(67);
hp[107] = makePTR(hp+100);
hp[108] = makeHDR(3);
hp[109] = makeCTR(C_Cons);
hp[110] = makeINT(79);
hp[111] = makePTR(hp+104);
hp[112] = makeHDR(3);
hp[113] = makeCTR(C_Cons);
hp[114] = makeINT(84);
hp[115] = makePTR(hp+108);
hp[116] = makeHDR(3);
hp[117] = makeCTR(C_Cons);
hp[118] = makeINT(79);
hp[119] = makeCTR(C_Nil);
hp[120] = makeHDR(3);
hp[121] = makeCTR(C_Cons);
hp[122] = makeINT(76);
hp[123] = makePTR(hp+116);
hp[124] = makeHDR(3);
hp[125] = makeCTR(C_Cons);
hp[126] = makeINT(73);
hp[127] = makePTR(hp+120);
hp[128] = makeHDR(3);
hp[129] = makeCTR(C_Cons);
hp[130] = makeINT(86);
hp[131] = makePTR(hp+124);
hp[132] = makeHDR(3);
hp[133] = makeCTR(C_Cons);
hp[134] = makeINT(69);
hp[135] = makePTR(hp+128);
hp[136] = makeHDR(3);
hp[137] = makeCTR(C_Cons);
hp[138] = makeINT(76);
hp[139] = makeCTR(C_Nil);
hp[140] = makeHDR(3);
hp[141] = makeCTR(C_Cons);
hp[142] = makeINT(69);
hp[143] = makePTR(hp+136);
hp[144] = makeHDR(3);
hp[145] = makeCTR(C_Cons);
hp[146] = makeINT(77);
hp[147] = makePTR(hp+140);
hp[148] = makeHDR(3);
hp[149] = makeCTR(C_Cons);
hp[150] = makeINT(79);
hp[151] = makePTR(hp+144);
hp[152] = makeHDR(3);
hp[153] = makeCTR(C_Cons);
hp[154] = makeINT(78);
hp[155] = makePTR(hp+148);
hp[156] = makeHDR(3);
hp[157] = makeCTR(C_Cons);
hp[158] = makeINT(71);
hp[159] = makeCTR(C_Nil);
hp[160] = makeHDR(3);
hp[161] = makeCTR(C_Cons);
hp[162] = makeINT(85);
hp[163] = makePTR(hp+156);
hp[164] = makeHDR(3);
hp[165] = makeCTR(C_Cons);
hp[166] = makeINT(65);
hp[167] = makePTR(hp+160);
hp[168] = makeHDR(3);
hp[169] = makeCTR(C_Cons);
hp[170] = makeINT(86);
hp[171] = makePTR(hp+164);
hp[172] = makeHDR(3);
hp[173] = makeCTR(C_Cons);
hp[174] = makeINT(65);
hp[175] = makePTR(hp+168);
hp[176] = makeHDR(3);
hp[177] = makeCTR(C_Cons);
hp[178] = makeINT(65);
hp[179] = makeCTR(C_Nil);
hp[180] = makeHDR(3);
hp[181] = makeCTR(C_Cons);
hp[182] = makeINT(86);
hp[183] = makePTR(hp+176);
hp[184] = makeHDR(3);
hp[185] = makeCTR(C_Cons);
hp[186] = makeINT(65);
hp[187] = makePTR(hp+180);
hp[188] = makeHDR(3);
hp[189] = makeCTR(C_Cons);
hp[190] = makeINT(67);
hp[191] = makePTR(hp+184);
hp[192] = makeHDR(3);
hp[193] = makeCTR(C_Cons);
hp[194] = makeINT(65);
hp[195] = makePTR(hp+188);
hp[196] = makeHDR(3);
hp[197] = makeCTR(C_Cons);
hp[198] = makeINT(68);
hp[199] = makePTR(hp+192);
hp[200] = makeHDR(3);
hp[201] = makeCTR(C_Cons);
hp[202] = makeINT(79);
hp[203] = makePTR(hp+196);
hp[204] = makeHDR(3);
hp[205] = makeCTR(C_Cons);
hp[206] = makeINT(80);
hp[207] = makeCTR(C_Nil);
hp[208] = makeHDR(3);
hp[209] = makeCTR(C_Cons);
hp[210] = makeINT(65);
hp[211] = makePTR(hp+204);
hp[212] = makeHDR(3);
hp[213] = makeCTR(C_Cons);
hp[214] = makeINT(80);
hp[215] = makePTR(hp+208);
hp[216] = makeHDR(3);
hp[217] = makeCTR(C_Cons);
hp[218] = makeINT(65);
hp[219] = makePTR(hp+212);
hp[220] = makeHDR(3);
hp[221] = makeCTR(C_Cons);
hp[222] = makeINT(89);
hp[223] = makePTR(hp+216);
hp[224] = makeHDR(3);
hp[225] = makeCTR(C_Cons);
hp[226] = makeINT(65);
hp[227] = makePTR(hp+220);
hp[228] = makeHDR(3);
hp[229] = makeCTR(C_Cons);
hp[230] = makeINT(76);
hp[231] = makeCTR(C_Nil);
hp[232] = makeHDR(3);
hp[233] = makeCTR(C_Cons);
hp[234] = makeINT(73);
hp[235] = makePTR(hp+228);
hp[236] = makeHDR(3);
hp[237] = makeCTR(C_Cons);
hp[238] = makeINT(84);
hp[239] = makePTR(hp+232);
hp[240] = makeHDR(3);
hp[241] = makeCTR(C_Cons);
hp[242] = makeINT(67);
hp[243] = makePTR(hp+236);
hp[244] = makeHDR(3);
hp[245] = makeCTR(C_Cons);
hp[246] = makeINT(72);
hp[247] = makePTR(hp+240);
hp[248] = makeHDR(3);
hp[249] = makeCTR(C_Cons);
hp[250] = makeINT(73);
hp[251] = makePTR(hp+244);
hp[252] = makeHDR(3);
hp[253] = makeCTR(C_Cons);
hp[254] = makeINT(77);
hp[255] = makeCTR(C_Nil);
hp[256] = makeHDR(3);
hp[257] = makeCTR(C_Cons);
hp[258] = makeINT(69);
hp[259] = makePTR(hp+252);
hp[260] = makeHDR(3);
hp[261] = makeCTR(C_Cons);
hp[262] = makeINT(76);
hp[263] = makePTR(hp+256);
hp[264] = makeHDR(3);
hp[265] = makeCTR(C_Cons);
hp[266] = makeINT(79);
hp[267] = makePTR(hp+260);
hp[268] = makeHDR(3);
hp[269] = makeCTR(C_Cons);
hp[270] = makeINT(78);
hp[271] = makePTR(hp+264);
hp[272] = makeHDR(3);
hp[273] = makeCTR(C_Cons);
hp[274] = makePTR(hp+268);
hp[275] = makeCTR(C_Nil);
hp[276] = makeHDR(3);
hp[277] = makeCTR(C_Cons);
hp[278] = makePTR(hp+248);
hp[279] = makePTR(hp+272);
hp[280] = makeHDR(3);
hp[281] = makeCTR(C_Cons);
hp[282] = makePTR(hp+224);
hp[283] = makePTR(hp+276);
hp[284] = makeHDR(3);
hp[285] = makeCTR(C_Cons);
hp[286] = makePTR(hp+200);
hp[287] = makePTR(hp+280);
hp[288] = makeHDR(3);
hp[289] = makeCTR(C_Cons);
hp[290] = makePTR(hp+172);
hp[291] = makePTR(hp+284);
hp[292] = makeHDR(3);
hp[293] = makeCTR(C_Cons);
hp[294] = makePTR(hp+152);
hp[295] = makePTR(hp+288);
hp[296] = makeHDR(3);
hp[297] = makeCTR(C_Cons);
hp[298] = makePTR(hp+132);
hp[299] = makePTR(hp+292);
hp[300] = makeHDR(3);
hp[301] = makeCTR(C_Cons);
hp[302] = makePTR(hp+112);
hp[303] = makePTR(hp+296);
hp[304] = makeHDR(3);
hp[305] = makeCTR(C_Cons);
hp[306] = makePTR(hp+84);
hp[307] = makePTR(hp+300);
hp[308] = makeHDR(3);
hp[309] = makeCTR(C_Cons);
hp[310] = makePTR(hp+64);
hp[311] = makePTR(hp+304);
hp[312] = makeHDR(3);
hp[313] = makeCTR(C_Cons);
hp[314] = makePTR(hp+40);
hp[315] = makePTR(hp+308);
hp[316] = makeHDR(3);
hp[317] = makeCTR(C_Cons);
hp[318] = makePTR(hp+20);
hp[319] = makePTR(hp+312);
hp[320] = makeHDR(5);
hp[321] = makeFUN(&&F_sumMapAccfx);
hp[322] = makePTR(hp+316);
hp[323] = makePTR(hp+316);
hp[324] = makePTR(hp+316);
hp[325] = makeINT(0);
atom = makePTR(hp+320);
hp += 326;
L_POP(1);
L_PUSH(atom);
goto F_sumMapAccfx;
F_fst:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_558;
  goto GC_COLLECT;
}
  GC_RET_558:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_559;
goto EVAL;
LABEL_559:
switch (res) {
case C_Pair:
atom = getPTR(L_sp[-1])[2];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_snd:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_560;
  goto GC_COLLECT;
}
  GC_RET_560:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_561;
goto EVAL;
LABEL_561:
switch (res) {
case C_Pair:
atom = getPTR(L_sp[-1])[3];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_rng:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_562;
  goto GC_COLLECT;
}
  GC_RET_562:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_563;
goto EVAL;
LABEL_563:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
case C_Cons:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_564;
goto EVAL;
LABEL_564:
switch (res) {
case C_Pair:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_rng);
hp[2] = getPTR(L_sp[-2])[3];
hp[3] = makeHDR(3);
hp[4] = makeCTR(C_Cons);
hp[5] = getPTR(L_sp[-1])[3];
hp[6] = makePTR(hp+0);
atom = makePTR(hp+3);
hp += 7;
L_POP(3);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
}
}
F_img:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_566;
  goto GC_COLLECT;
}
  GC_RET_566:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_lookup);
hp[2] = getPTR(L_sp[-1])[3];
hp[3] = getPTR(L_sp[-1])[2];
atom = makePTR(hp+0);
hp += 4;
eval_ret_addr = &&LABEL_567;
goto EVAL;
LABEL_567:
switch (res) {
case C_Just:
atom = getPTR(L_sp[-1])[2];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_fromJust:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_568;
  goto GC_COLLECT;
}
  GC_RET_568:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_569;
goto EVAL;
LABEL_569:
switch (res) {
case C_Just:
atom = getPTR(L_sp[-1])[2];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_lookup:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_570;
  goto GC_COLLECT;
}
  GC_RET_570:
atom = getPTR(L_sp[-1])[3];
getPTR(L_sp[-1])[3] = makeINT(0);
eval_ret_addr = &&LABEL_571;
goto EVAL;
LABEL_571:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_Nothing));
res = C_Nothing;
goto EVAL_RET;
case C_Cons:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_572;
goto EVAL;
LABEL_572:
switch (res) {
case C_Pair:
atom = getPTR(L_sp[-3])[2];
eval_ret_addr = &&LABEL_573;
goto EVAL;
LABEL_573:
atom = getPTR(L_sp[-2])[2];
eval_ret_addr = &&LABEL_574;
goto EVAL;
LABEL_574:
L_POP(1);
res = getINT(L_top) == res ? C_True : C_False;
L_POP(1);
L_PUSH(makeCTR(res));
switch (res) {
case C_False:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_lookup);
hp[2] = getPTR(L_sp[-4])[2];
hp[3] = getPTR(L_sp[-3])[3];
atom = makePTR(hp+0);
hp += 4;
L_POP(4);
L_PUSH(atom);
goto F_lookup;
case C_True:
hp[0] = makeHDR(2);
hp[1] = makeCTR(C_Just);
hp[2] = getPTR(L_sp[-2])[3];
atom = makePTR(hp+0);
hp += 3;
L_POP(4);
L_PUSH(atom);
res = C_Just;
goto EVAL_RET;
}
}
}
F_del:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_575;
  goto GC_COLLECT;
}
  GC_RET_575:
atom = getPTR(L_sp[-1])[3];
getPTR(L_sp[-1])[3] = makeINT(0);
eval_ret_addr = &&LABEL_576;
goto EVAL;
LABEL_576:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
case C_Cons:
atom = getPTR(L_sp[-2])[2];
eval_ret_addr = &&LABEL_577;
goto EVAL;
LABEL_577:
atom = getPTR(L_sp[-2])[2];
eval_ret_addr = &&LABEL_578;
goto EVAL;
LABEL_578:
L_POP(1);
res = getINT(L_top) == res ? C_True : C_False;
L_POP(1);
L_PUSH(makeCTR(res));
switch (res) {
case C_False:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_del);
hp[2] = getPTR(L_sp[-3])[2];
hp[3] = getPTR(L_sp[-2])[3];
hp[4] = makeHDR(3);
hp[5] = makeCTR(C_Cons);
hp[6] = getPTR(L_sp[-2])[2];
hp[7] = makePTR(hp+0);
atom = makePTR(hp+4);
hp += 8;
L_POP(3);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
case C_True:
atom = getPTR(L_sp[-2])[3];
L_POP(3);
goto TAIL_EVAL;
goto EVAL_RET;
}
}
F_member:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_580;
  goto GC_COLLECT;
}
  GC_RET_580:
atom = getPTR(L_sp[-1])[3];
getPTR(L_sp[-1])[3] = makeINT(0);
eval_ret_addr = &&LABEL_581;
goto EVAL;
LABEL_581:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_False));
res = C_False;
goto EVAL_RET;
case C_Cons:
atom = getPTR(L_sp[-2])[2];
eval_ret_addr = &&LABEL_582;
goto EVAL;
LABEL_582:
atom = getPTR(L_sp[-2])[2];
eval_ret_addr = &&LABEL_583;
goto EVAL;
LABEL_583:
L_POP(1);
res = getINT(L_top) == res ? C_True : C_False;
L_POP(1);
L_PUSH(makeCTR(res));
switch (res) {
case C_False:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_member);
hp[2] = getPTR(L_sp[-3])[2];
hp[3] = getPTR(L_sp[-2])[3];
atom = makePTR(hp+0);
hp += 4;
L_POP(3);
L_PUSH(atom);
goto F_member;
case C_True:
L_POP(3);
L_PUSH(makeCTR(C_True));
res = C_True;
goto EVAL_RET;
}
}
F_diff:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_584;
  goto GC_COLLECT;
}
  GC_RET_584:
atom = getPTR(L_sp[-1])[3];
getPTR(L_sp[-1])[3] = makeINT(0);
eval_ret_addr = &&LABEL_585;
goto EVAL;
LABEL_585:
switch (res) {
case C_Nil:
atom = getPTR(L_sp[-2])[2];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_del);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = getPTR(L_sp[-2])[2];
hp[4] = makeHDR(3);
hp[5] = makeFUN(&&F_diff);
hp[6] = makePTR(hp+0);
hp[7] = getPTR(L_sp[-1])[3];
atom = makePTR(hp+4);
hp += 8;
L_POP(2);
L_PUSH(atom);
goto F_diff;
}
F_repeat:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_587;
  goto GC_COLLECT;
}
  GC_RET_587:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_repeat);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = makeHDR(3);
hp[4] = makeCTR(C_Cons);
hp[5] = getPTR(L_sp[-1])[2];
hp[6] = makePTR(hp+0);
atom = makePTR(hp+3);
hp += 7;
L_POP(1);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
F_zip:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_589;
  goto GC_COLLECT;
}
  GC_RET_589:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_590;
goto EVAL;
LABEL_590:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
case C_Cons:
atom = getPTR(L_sp[-2])[3];
getPTR(L_sp[-2])[3] = makeINT(0);
eval_ret_addr = &&LABEL_591;
goto EVAL;
LABEL_591:
switch (res) {
case C_Nil:
L_POP(3);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(3);
hp[1] = makeCTR(C_Pair);
hp[2] = getPTR(L_sp[-2])[2];
hp[3] = getPTR(L_sp[-1])[2];
hp[4] = makeHDR(3);
hp[5] = makeFUN(&&F_zip);
hp[6] = getPTR(L_sp[-2])[3];
hp[7] = getPTR(L_sp[-1])[3];
hp[8] = makeHDR(3);
hp[9] = makeCTR(C_Cons);
hp[10] = makePTR(hp+0);
hp[11] = makePTR(hp+4);
atom = makePTR(hp+8);
hp += 12;
L_POP(3);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
}
}
F_mapFlipCons:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_594;
  goto GC_COLLECT;
}
  GC_RET_594:
atom = getPTR(L_sp[-1])[3];
getPTR(L_sp[-1])[3] = makeINT(0);
eval_ret_addr = &&LABEL_595;
goto EVAL;
LABEL_595:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(3);
hp[1] = makeCTR(C_Cons);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = getPTR(L_sp[-2])[2];
hp[4] = makeHDR(3);
hp[5] = makeFUN(&&F_mapFlipCons);
hp[6] = getPTR(L_sp[-2])[2];
hp[7] = getPTR(L_sp[-1])[3];
hp[8] = makeHDR(3);
hp[9] = makeCTR(C_Cons);
hp[10] = makePTR(hp+0);
hp[11] = makePTR(hp+4);
atom = makePTR(hp+8);
hp += 12;
L_POP(2);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
}
F_bindings:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_598;
  goto GC_COLLECT;
}
  GC_RET_598:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_lookup);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = getPTR(L_sp[-1])[4];
atom = makePTR(hp+0);
hp += 4;
eval_ret_addr = &&LABEL_599;
goto EVAL;
LABEL_599:
switch (res) {
case C_Nothing:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_repeat);
hp[2] = getPTR(L_sp[-2])[2];
hp[3] = makeHDR(2);
hp[4] = makeFUN(&&F_rng);
hp[5] = getPTR(L_sp[-2])[4];
hp[6] = makeHDR(3);
hp[7] = makeFUN(&&F_diff);
hp[8] = getPTR(L_sp[-2])[3];
hp[9] = makePTR(hp+3);
hp[10] = makeHDR(3);
hp[11] = makeFUN(&&F_zip);
hp[12] = makePTR(hp+0);
hp[13] = makePTR(hp+6);
hp[14] = makeHDR(3);
hp[15] = makeFUN(&&F_mapFlipCons);
hp[16] = getPTR(L_sp[-2])[4];
hp[17] = makePTR(hp+10);
atom = makePTR(hp+14);
hp += 18;
L_POP(2);
L_PUSH(atom);
goto F_mapFlipCons;
case C_Just:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_member);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = getPTR(L_sp[-2])[3];
atom = makePTR(hp+0);
hp += 4;
eval_ret_addr = &&LABEL_604;
goto EVAL;
LABEL_604:
switch (res) {
case C_True:
hp[0] = makeHDR(3);
hp[1] = makeCTR(C_Cons);
hp[2] = getPTR(L_sp[-3])[4];
hp[3] = makeCTR(C_Nil);
atom = makePTR(hp+0);
hp += 4;
L_POP(3);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
case C_False:
L_POP(3);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
}
}
F_append:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_605;
  goto GC_COLLECT;
}
  GC_RET_605:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_606;
goto EVAL;
LABEL_606:
switch (res) {
case C_Nil:
atom = getPTR(L_sp[-2])[3];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_append);
hp[2] = getPTR(L_sp[-1])[3];
hp[3] = getPTR(L_sp[-2])[3];
hp[4] = makeHDR(3);
hp[5] = makeCTR(C_Cons);
hp[6] = getPTR(L_sp[-1])[2];
hp[7] = makePTR(hp+0);
atom = makePTR(hp+4);
hp += 8;
L_POP(2);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
}
F_ofAll1:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_608;
  goto GC_COLLECT;
}
  GC_RET_608:
atom = getPTR(L_sp[-1])[8];
getPTR(L_sp[-1])[8] = makeINT(0);
eval_ret_addr = &&LABEL_609;
goto EVAL;
LABEL_609:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_ofAll1___0);
hp[2] = getPTR(L_sp[-2])[2];
hp[3] = makeHDR(2);
hp[4] = makeFUN(&&F_ofAll1___1);
hp[5] = getPTR(L_sp[-2])[3];
hp[6] = makeHDR(9);
hp[7] = makeFUN(&&F_solns);
hp[8] = makePTR(hp+0);
hp[9] = getPTR(L_sp[-2])[4];
hp[10] = makePTR(hp+3);
hp[11] = getPTR(L_sp[-2])[5];
hp[12] = getPTR(L_sp[-2])[6];
hp[13] = getPTR(L_sp[-2])[3];
hp[14] = getPTR(L_sp[-2])[7];
hp[15] = getPTR(L_sp[-1])[2];
hp[16] = makeHDR(8);
hp[17] = makeFUN(&&F_ofAll1);
hp[18] = getPTR(L_sp[-2])[2];
hp[19] = getPTR(L_sp[-2])[3];
hp[20] = getPTR(L_sp[-2])[4];
hp[21] = getPTR(L_sp[-2])[5];
hp[22] = getPTR(L_sp[-2])[6];
hp[23] = getPTR(L_sp[-2])[7];
hp[24] = getPTR(L_sp[-1])[3];
hp[25] = makeHDR(3);
hp[26] = makeFUN(&&F_append);
hp[27] = makePTR(hp+6);
hp[28] = makePTR(hp+16);
atom = makePTR(hp+25);
hp += 29;
L_POP(2);
L_PUSH(atom);
goto F_append;
}
F_ofAll1___0:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_614;
  goto GC_COLLECT;
}
  GC_RET_614:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_615;
goto EVAL;
LABEL_615:
switch (res) {
case C_Pair:
atom = getPTR(L_sp[-1])[2];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_ofAll1___1:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_616;
  goto GC_COLLECT;
}
  GC_RET_616:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_617;
goto EVAL;
LABEL_617:
switch (res) {
case C_Cons:
atom = getPTR(L_sp[-1])[2];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_ofAll2:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_618;
  goto GC_COLLECT;
}
  GC_RET_618:
atom = getPTR(L_sp[-1])[3];
getPTR(L_sp[-1])[3] = makeINT(0);
eval_ret_addr = &&LABEL_619;
goto EVAL;
LABEL_619:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_ofAll2___0);
hp[2] = getPTR(L_sp[-2])[2];
hp[3] = makeHDR(2);
hp[4] = makeFUN(&&F_ofAll2___1);
hp[5] = getPTR(L_sp[-2])[2];
hp[6] = makeHDR(3);
hp[7] = makeFUN(&&F_fromTo);
hp[8] = makePTR(hp+3);
hp[9] = makeINT(9);
hp[10] = makeHDR(4);
hp[11] = makeFUN(&&F_bindings);
hp[12] = makePTR(hp+0);
hp[13] = makePTR(hp+6);
hp[14] = getPTR(L_sp[-1])[2];
hp[15] = makeHDR(3);
hp[16] = makeFUN(&&F_ofAll2);
hp[17] = getPTR(L_sp[-2])[2];
hp[18] = getPTR(L_sp[-1])[3];
hp[19] = makeHDR(3);
hp[20] = makeFUN(&&F_append);
hp[21] = makePTR(hp+10);
hp[22] = makePTR(hp+15);
atom = makePTR(hp+19);
hp += 23;
L_POP(2);
L_PUSH(atom);
goto F_append;
}
F_ofAll2___0:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_625;
  goto GC_COLLECT;
}
  GC_RET_625:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_626;
goto EVAL;
LABEL_626:
switch (res) {
case C_Cons:
atom = getPTR(L_sp[-1])[2];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_ofAll2___1:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_627;
  goto GC_COLLECT;
}
  GC_RET_627:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_628;
goto EVAL;
LABEL_628:
switch (res) {
case C_Cons:
atom = getPTR(L_sp[-1])[3];
eval_ret_addr = &&LABEL_629;
goto EVAL;
LABEL_629:
switch (res) {
case C_Nil:
L_POP(3);
L_PUSH(makeINT(1));
res = 1;
goto EVAL_RET;
case C_Cons:
L_POP(3);
L_PUSH(makeINT(0));
res = 0;
goto EVAL_RET;
}
}
F_ifNull:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_630;
  goto GC_COLLECT;
}
  GC_RET_630:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_631;
goto EVAL;
LABEL_631:
switch (res) {
case C_Nil:
atom = getPTR(L_sp[-2])[3];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
case C_Cons:
atom = getPTR(L_sp[-2])[4];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_head:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_632;
  goto GC_COLLECT;
}
  GC_RET_632:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_633;
goto EVAL;
LABEL_633:
switch (res) {
case C_Cons:
atom = getPTR(L_sp[-1])[2];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_tail:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_634;
  goto GC_COLLECT;
}
  GC_RET_634:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_635;
goto EVAL;
LABEL_635:
switch (res) {
case C_Cons:
atom = getPTR(L_sp[-1])[3];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_solutions:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_636;
  goto GC_COLLECT;
}
  GC_RET_636:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_637;
goto EVAL;
LABEL_637:
switch (res) {
case C_Nil:
atom = getPTR(L_sp[-2])[4];
getPTR(L_sp[-2])[4] = makeINT(0);
eval_ret_addr = &&LABEL_638;
goto EVAL;
LABEL_638:
switch (res) {
case C_Nil:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_solutions___0);
hp[2] = getPTR(L_sp[-3])[5];
atom = makePTR(hp+0);
hp += 3;
eval_ret_addr = &&LABEL_639;
goto EVAL;
LABEL_639:
L_PUSH(makeINT(0));
res = 0;
L_POP(1);
res = getINT(L_top) == res ? C_True : C_False;
L_POP(1);
L_PUSH(makeCTR(res));
switch (res) {
case C_False:
L_POP(4);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
case C_True:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_solutions___1);
hp[2] = getPTR(L_sp[-4])[5];
hp[3] = makeHDR(3);
hp[4] = makeCTR(C_Cons);
hp[5] = makePTR(hp+0);
hp[6] = makeCTR(C_Nil);
atom = makePTR(hp+3);
hp += 7;
L_POP(4);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
}
case C_Cons:
atom = getPTR(L_sp[-1])[3];
eval_ret_addr = &&LABEL_641;
goto EVAL;
LABEL_641:
switch (res) {
case C_Nil:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_solutions___2);
hp[2] = getPTR(L_sp[-4])[5];
atom = makePTR(hp+0);
hp += 3;
eval_ret_addr = &&LABEL_642;
goto EVAL;
LABEL_642:
L_PUSH(makeINT(1));
res = 1;
L_POP(1);
res = getINT(L_top) == res ? C_True : C_False;
L_POP(1);
L_PUSH(makeCTR(res));
switch (res) {
case C_False:
L_POP(5);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
case C_True:
hp[0] = makeHDR(3);
hp[1] = makeCTR(C_Cons);
hp[2] = makeINT(1);
hp[3] = makeCTR(C_Nil);
hp[4] = makeHDR(2);
hp[5] = makeFUN(&&F_solutions___3);
hp[6] = getPTR(L_sp[-5])[5];
hp[7] = makeHDR(4);
hp[8] = makeFUN(&&F_bindings);
hp[9] = getPTR(L_sp[-3])[2];
hp[10] = makePTR(hp+0);
hp[11] = makePTR(hp+4);
atom = makePTR(hp+7);
hp += 12;
L_POP(5);
L_PUSH(atom);
goto F_bindings;
}
}
}
case C_Cons:
atom = getPTR(L_sp[-2])[4];
getPTR(L_sp[-2])[4] = makeINT(0);
eval_ret_addr = &&LABEL_645;
goto EVAL;
LABEL_645:
switch (res) {
case C_Cons:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_solutions___4);
hp[2] = getPTR(L_sp[-2])[3];
hp[3] = makeHDR(3);
hp[4] = makeFUN(&&F_fromTo);
hp[5] = makePTR(hp+0);
hp[6] = makeINT(9);
hp[7] = makeHDR(2);
hp[8] = makeFUN(&&F_solutions___5);
hp[9] = getPTR(L_sp[-3])[5];
hp[10] = makeHDR(4);
hp[11] = makeFUN(&&F_bindings);
hp[12] = getPTR(L_sp[-2])[2];
hp[13] = makePTR(hp+3);
hp[14] = makePTR(hp+7);
hp[15] = makeHDR(3);
hp[16] = makeFUN(&&F_ofAll2);
hp[17] = getPTR(L_sp[-3])[3];
hp[18] = makePTR(hp+10);
hp[19] = makeHDR(8);
hp[20] = makeFUN(&&F_ofAll1);
hp[21] = getPTR(L_sp[-3])[5];
hp[22] = getPTR(L_sp[-3])[3];
hp[23] = getPTR(L_sp[-2])[2];
hp[24] = getPTR(L_sp[-1])[2];
hp[25] = getPTR(L_sp[-2])[3];
hp[26] = getPTR(L_sp[-1])[3];
hp[27] = makePTR(hp+15);
atom = makePTR(hp+19);
hp += 28;
L_POP(3);
L_PUSH(atom);
goto F_ofAll1;
}
}
F_solutions___0:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_651;
  goto GC_COLLECT;
}
  GC_RET_651:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_652;
goto EVAL;
LABEL_652:
switch (res) {
case C_Pair:
atom = getPTR(L_sp[-1])[2];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_solutions___1:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_653;
  goto GC_COLLECT;
}
  GC_RET_653:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_654;
goto EVAL;
LABEL_654:
switch (res) {
case C_Pair:
atom = getPTR(L_sp[-1])[3];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_solutions___2:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_655;
  goto GC_COLLECT;
}
  GC_RET_655:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_656;
goto EVAL;
LABEL_656:
switch (res) {
case C_Pair:
atom = getPTR(L_sp[-1])[2];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_solutions___3:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_657;
  goto GC_COLLECT;
}
  GC_RET_657:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_658;
goto EVAL;
LABEL_658:
switch (res) {
case C_Pair:
atom = getPTR(L_sp[-1])[3];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_solutions___4:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_659;
  goto GC_COLLECT;
}
  GC_RET_659:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_660;
goto EVAL;
LABEL_660:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeINT(1));
res = 1;
goto EVAL_RET;
case C_Cons:
L_POP(2);
L_PUSH(makeINT(0));
res = 0;
goto EVAL_RET;
}
F_solutions___5:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_661;
  goto GC_COLLECT;
}
  GC_RET_661:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_662;
goto EVAL;
LABEL_662:
switch (res) {
case C_Pair:
atom = getPTR(L_sp[-1])[3];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_ofAll3:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_663;
  goto GC_COLLECT;
}
  GC_RET_663:
atom = getPTR(L_sp[-1])[6];
getPTR(L_sp[-1])[6] = makeINT(0);
eval_ret_addr = &&LABEL_664;
goto EVAL;
LABEL_664:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(2);
hp[1] = makeFUN(&&F_ofAll3___0);
hp[2] = getPTR(L_sp[-2])[3];
hp[3] = makeHDR(2);
hp[4] = makeFUN(&&F_ofAll3___1);
hp[5] = getPTR(L_sp[-2])[5];
hp[6] = makeHDR(3);
hp[7] = makeCTR(C_Pair);
hp[8] = makePTR(hp+3);
hp[9] = getPTR(L_sp[-1])[2];
hp[10] = makeHDR(5);
hp[11] = makeFUN(&&F_solutions);
hp[12] = getPTR(L_sp[-2])[2];
hp[13] = makePTR(hp+0);
hp[14] = getPTR(L_sp[-2])[4];
hp[15] = makePTR(hp+6);
hp[16] = makeHDR(6);
hp[17] = makeFUN(&&F_ofAll3);
hp[18] = getPTR(L_sp[-2])[2];
hp[19] = getPTR(L_sp[-2])[3];
hp[20] = getPTR(L_sp[-2])[4];
hp[21] = getPTR(L_sp[-2])[5];
hp[22] = getPTR(L_sp[-1])[3];
hp[23] = makeHDR(3);
hp[24] = makeFUN(&&F_append);
hp[25] = makePTR(hp+10);
hp[26] = makePTR(hp+16);
atom = makePTR(hp+23);
hp += 27;
L_POP(2);
L_PUSH(atom);
goto F_append;
}
F_ofAll3___0:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_670;
  goto GC_COLLECT;
}
  GC_RET_670:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_671;
goto EVAL;
LABEL_671:
switch (res) {
case C_Cons:
atom = getPTR(L_sp[-1])[3];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_ofAll3___1:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_672;
  goto GC_COLLECT;
}
  GC_RET_672:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_673;
goto EVAL;
LABEL_673:
switch (res) {
case C_Pair:
atom = getPTR(L_sp[-1])[2];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_solns:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_674;
  goto GC_COLLECT;
}
  GC_RET_674:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_solns___0);
hp[2] = getPTR(L_sp[-1])[3];
hp[3] = getPTR(L_sp[-1])[9];
hp[4] = makeHDR(3);
hp[5] = makeFUN(&&F_solns___1);
hp[6] = getPTR(L_sp[-1])[4];
hp[7] = getPTR(L_sp[-1])[9];
hp[8] = makeHDR(3);
hp[9] = makeFUN(&&P_ADD);
hp[10] = makePTR(hp+0);
hp[11] = makePTR(hp+4);
hp[12] = makeHDR(3);
hp[13] = makeFUN(&&P_ADD);
hp[14] = makePTR(hp+8);
hp[15] = getPTR(L_sp[-1])[2];
hp[16] = makeHDR(2);
hp[17] = makeFUN(&&F_divMod10);
hp[18] = makePTR(hp+12);
hp[19] = makeHDR(2);
hp[20] = makeFUN(&&F_solns___2);
hp[21] = makePTR(hp+16);
hp[22] = makeHDR(3);
hp[23] = makeCTR(C_Cons);
hp[24] = makePTR(hp+19);
hp[25] = makeCTR(C_Nil);
hp[26] = makeHDR(4);
hp[27] = makeFUN(&&F_bindings);
hp[28] = getPTR(L_sp[-1])[5];
hp[29] = makePTR(hp+22);
hp[30] = getPTR(L_sp[-1])[9];
hp[31] = makeHDR(6);
hp[32] = makeFUN(&&F_ofAll3);
hp[33] = getPTR(L_sp[-1])[6];
hp[34] = getPTR(L_sp[-1])[7];
hp[35] = getPTR(L_sp[-1])[8];
hp[36] = makePTR(hp+16);
hp[37] = makePTR(hp+26);
atom = makePTR(hp+31);
hp += 38;
L_POP(1);
L_PUSH(atom);
goto F_ofAll3;
F_solns___0:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_682;
  goto GC_COLLECT;
}
  GC_RET_682:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_lookup);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = getPTR(L_sp[-1])[3];
atom = makePTR(hp+0);
hp += 4;
eval_ret_addr = &&LABEL_683;
goto EVAL;
LABEL_683:
switch (res) {
case C_Just:
atom = getPTR(L_sp[-1])[2];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_solns___1:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_684;
  goto GC_COLLECT;
}
  GC_RET_684:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_lookup);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = getPTR(L_sp[-1])[3];
atom = makePTR(hp+0);
hp += 4;
eval_ret_addr = &&LABEL_685;
goto EVAL;
LABEL_685:
switch (res) {
case C_Just:
atom = getPTR(L_sp[-1])[2];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_solns___2:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_686;
  goto GC_COLLECT;
}
  GC_RET_686:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_687;
goto EVAL;
LABEL_687:
switch (res) {
case C_Pair:
atom = getPTR(L_sp[-1])[3];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_divMod10:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_688;
  goto GC_COLLECT;
}
  GC_RET_688:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_689;
goto EVAL;
LABEL_689:
L_PUSH(makeINT(9));
res = 9;
L_POP(1);
res = getINT(L_top) <= res ? C_True : C_False;
L_POP(1);
L_PUSH(makeCTR(res));
switch (res) {
case C_True:
hp[0] = makeHDR(3);
hp[1] = makeCTR(C_Pair);
hp[2] = makeINT(0);
hp[3] = getPTR(L_sp[-2])[2];
atom = makePTR(hp+0);
hp += 4;
L_POP(2);
L_PUSH(atom);
res = C_Pair;
goto EVAL_RET;
case C_False:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&P_SUB);
hp[2] = getPTR(L_sp[-2])[2];
hp[3] = makeINT(10);
hp[4] = makeHDR(2);
hp[5] = makeFUN(&&F_divMod10);
hp[6] = makePTR(hp+0);
atom = makePTR(hp+4);
hp += 7;
eval_ret_addr = &&LABEL_691;
goto EVAL;
LABEL_691:
switch (res) {
case C_Pair:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&P_ADD);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = makeINT(1);
hp[4] = makeHDR(3);
hp[5] = makeCTR(C_Pair);
hp[6] = makePTR(hp+0);
hp[7] = getPTR(L_sp[-1])[3];
atom = makePTR(hp+4);
hp += 8;
L_POP(3);
L_PUSH(atom);
res = C_Pair;
goto EVAL_RET;
}
}
F_fromTo:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_693;
  goto GC_COLLECT;
}
  GC_RET_693:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_fromTo___0);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = getPTR(L_sp[-1])[3];
hp[4] = makeHDR(3);
hp[5] = makeCTR(C_Cons);
hp[6] = getPTR(L_sp[-1])[2];
hp[7] = makePTR(hp+0);
atom = makePTR(hp+4);
hp += 8;
L_POP(1);
L_PUSH(atom);
res = C_Cons;
goto EVAL_RET;
F_fromTo___0:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_695;
  goto GC_COLLECT;
}
  GC_RET_695:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_696;
goto EVAL;
LABEL_696:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_697;
goto EVAL;
LABEL_697:
L_POP(1);
res = getINT(L_top) == res ? C_True : C_False;
L_POP(1);
L_PUSH(makeCTR(res));
switch (res) {
case C_True:
L_POP(2);
L_PUSH(makeCTR(C_Nil));
res = C_Nil;
goto EVAL_RET;
case C_False:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&P_ADD);
hp[2] = getPTR(L_sp[-2])[2];
hp[3] = makeINT(1);
hp[4] = makeHDR(3);
hp[5] = makeFUN(&&F_fromTo);
hp[6] = makePTR(hp+0);
hp[7] = getPTR(L_sp[-2])[3];
atom = makePTR(hp+4);
hp += 8;
L_POP(2);
L_PUSH(atom);
goto F_fromTo;
}
F_isSingleton:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_699;
  goto GC_COLLECT;
}
  GC_RET_699:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_700;
goto EVAL;
LABEL_700:
switch (res) {
case C_Nil:
L_POP(2);
L_PUSH(makeCTR(C_False));
res = C_False;
goto EVAL_RET;
case C_Cons:
atom = getPTR(L_sp[-1])[3];
eval_ret_addr = &&LABEL_701;
goto EVAL;
LABEL_701:
switch (res) {
case C_Nil:
L_POP(3);
L_PUSH(makeCTR(C_True));
res = C_True;
goto EVAL_RET;
case C_Cons:
L_POP(3);
L_PUSH(makeCTR(C_False));
res = C_False;
goto EVAL_RET;
}
}
F_and:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_702;
  goto GC_COLLECT;
}
  GC_RET_702:
atom = getPTR(L_sp[-1])[2];
getPTR(L_sp[-1])[2] = makeINT(0);
eval_ret_addr = &&LABEL_703;
goto EVAL;
LABEL_703:
switch (res) {
case C_False:
L_POP(2);
L_PUSH(makeCTR(C_False));
res = C_False;
goto EVAL_RET;
case C_True:
atom = getPTR(L_sp[-2])[3];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
}
F_valid:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_704;
  goto GC_COLLECT;
}
  GC_RET_704:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_lengthAcc);
hp[2] = makeINT(0);
hp[3] = getPTR(L_sp[-1])[2];
atom = makePTR(hp+0);
hp += 4;
eval_ret_addr = &&LABEL_705;
goto EVAL;
LABEL_705:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_lengthAcc);
hp[2] = makeINT(0);
hp[3] = getPTR(L_sp[-2])[3];
atom = makePTR(hp+0);
hp += 4;
eval_ret_addr = &&LABEL_706;
goto EVAL;
LABEL_706:
L_POP(1);
res = getINT(L_top) == res ? C_True : C_False;
L_POP(1);
L_PUSH(makeCTR(res));
switch (res) {
case C_False:
L_POP(2);
L_PUSH(makeCTR(C_False));
res = C_False;
goto EVAL_RET;
case C_True:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_lengthAcc);
hp[2] = makeINT(0);
hp[3] = getPTR(L_sp[-2])[2];
atom = makePTR(hp+0);
hp += 4;
eval_ret_addr = &&LABEL_707;
goto EVAL;
LABEL_707:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_lengthAcc);
hp[2] = makeINT(0);
hp[3] = getPTR(L_sp[-3])[4];
atom = makePTR(hp+0);
hp += 4;
eval_ret_addr = &&LABEL_708;
goto EVAL;
LABEL_708:
L_POP(1);
res = getINT(L_top) == res ? C_True : C_False;
L_POP(1);
L_PUSH(makeCTR(res));
switch (res) {
case C_False:
L_POP(3);
L_PUSH(makeCTR(C_False));
res = C_False;
goto EVAL_RET;
case C_True:
hp[0] = makeHDR(3);
hp[1] = makeCTR(C_Pair);
hp[2] = makeINT(0);
hp[3] = makeCTR(C_Nil);
hp[4] = makeHDR(5);
hp[5] = makeFUN(&&F_solutions);
hp[6] = getPTR(L_sp[-3])[2];
hp[7] = getPTR(L_sp[-3])[3];
hp[8] = getPTR(L_sp[-3])[4];
hp[9] = makePTR(hp+0);
atom = makePTR(hp+4);
hp += 10;
eval_ret_addr = &&LABEL_710;
goto EVAL;
LABEL_710:
switch (res) {
case C_Nil:
L_POP(4);
L_PUSH(makeCTR(C_False));
res = C_False;
goto EVAL_RET;
case C_Cons:
atom = getPTR(L_sp[-1])[3];
eval_ret_addr = &&LABEL_711;
goto EVAL;
LABEL_711:
switch (res) {
case C_Nil:
L_POP(5);
L_PUSH(makeCTR(C_True));
res = C_True;
goto EVAL_RET;
case C_Cons:
L_POP(5);
L_PUSH(makeCTR(C_False));
res = C_False;
goto EVAL_RET;
}
}
}
}
F_sumMapAccfx:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_712;
  goto GC_COLLECT;
}
  GC_RET_712:
atom = getPTR(L_sp[-1])[4];
getPTR(L_sp[-1])[4] = makeINT(0);
eval_ret_addr = &&LABEL_713;
goto EVAL;
LABEL_713:
switch (res) {
case C_Nil:
atom = getPTR(L_sp[-2])[5];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(5);
hp[1] = makeFUN(&&F_sumMapAccfy);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = getPTR(L_sp[-2])[3];
hp[4] = getPTR(L_sp[-2])[2];
hp[5] = makeINT(0);
hp[6] = makeHDR(3);
hp[7] = makeFUN(&&P_ADD);
hp[8] = makePTR(hp+0);
hp[9] = getPTR(L_sp[-2])[5];
hp[10] = makeHDR(5);
hp[11] = makeFUN(&&F_sumMapAccfx);
hp[12] = getPTR(L_sp[-2])[2];
hp[13] = getPTR(L_sp[-2])[3];
hp[14] = getPTR(L_sp[-1])[3];
hp[15] = makePTR(hp+6);
atom = makePTR(hp+10);
hp += 16;
L_POP(2);
L_PUSH(atom);
goto F_sumMapAccfx;
}
F_count:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_716;
  goto GC_COLLECT;
}
  GC_RET_716:
hp[0] = makeHDR(5);
hp[1] = makeFUN(&&F_sumMapAccfx);
hp[2] = getPTR(L_sp[-1])[3];
hp[3] = getPTR(L_sp[-1])[4];
hp[4] = getPTR(L_sp[-1])[2];
hp[5] = makeINT(0);
atom = makePTR(hp+0);
hp += 6;
L_POP(1);
L_PUSH(atom);
goto F_sumMapAccfx;
F_fx:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_717;
  goto GC_COLLECT;
}
  GC_RET_717:
hp[0] = makeHDR(5);
hp[1] = makeFUN(&&F_sumMapAccfy);
hp[2] = getPTR(L_sp[-1])[4];
hp[3] = getPTR(L_sp[-1])[3];
hp[4] = getPTR(L_sp[-1])[2];
hp[5] = makeINT(0);
atom = makePTR(hp+0);
hp += 6;
L_POP(1);
L_PUSH(atom);
goto F_sumMapAccfy;
F_sumMapAccfy:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_718;
  goto GC_COLLECT;
}
  GC_RET_718:
atom = getPTR(L_sp[-1])[4];
getPTR(L_sp[-1])[4] = makeINT(0);
eval_ret_addr = &&LABEL_719;
goto EVAL;
LABEL_719:
switch (res) {
case C_Nil:
atom = getPTR(L_sp[-2])[5];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(5);
hp[1] = makeFUN(&&F_sumMapAccfz);
hp[2] = getPTR(L_sp[-2])[2];
hp[3] = getPTR(L_sp[-1])[2];
hp[4] = getPTR(L_sp[-2])[3];
hp[5] = makeINT(0);
hp[6] = makeHDR(3);
hp[7] = makeFUN(&&P_ADD);
hp[8] = makePTR(hp+0);
hp[9] = getPTR(L_sp[-2])[5];
hp[10] = makeHDR(5);
hp[11] = makeFUN(&&F_sumMapAccfy);
hp[12] = getPTR(L_sp[-2])[2];
hp[13] = getPTR(L_sp[-2])[3];
hp[14] = getPTR(L_sp[-1])[3];
hp[15] = makePTR(hp+6);
atom = makePTR(hp+10);
hp += 16;
L_POP(2);
L_PUSH(atom);
goto F_sumMapAccfy;
}
F_fy:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_722;
  goto GC_COLLECT;
}
  GC_RET_722:
hp[0] = makeHDR(5);
hp[1] = makeFUN(&&F_sumMapAccfz);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = getPTR(L_sp[-1])[4];
hp[4] = getPTR(L_sp[-1])[3];
hp[5] = makeINT(0);
atom = makePTR(hp+0);
hp += 6;
L_POP(1);
L_PUSH(atom);
goto F_sumMapAccfz;
F_sumMapAccfz:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_723;
  goto GC_COLLECT;
}
  GC_RET_723:
atom = getPTR(L_sp[-1])[4];
getPTR(L_sp[-1])[4] = makeINT(0);
eval_ret_addr = &&LABEL_724;
goto EVAL;
LABEL_724:
switch (res) {
case C_Nil:
atom = getPTR(L_sp[-2])[5];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(4);
hp[1] = makeFUN(&&F_sumMapAccfz___0);
hp[2] = getPTR(L_sp[-2])[2];
hp[3] = getPTR(L_sp[-2])[3];
hp[4] = getPTR(L_sp[-1])[2];
hp[5] = makeHDR(3);
hp[6] = makeFUN(&&P_ADD);
hp[7] = makePTR(hp+0);
hp[8] = getPTR(L_sp[-2])[5];
hp[9] = makeHDR(5);
hp[10] = makeFUN(&&F_sumMapAccfz);
hp[11] = getPTR(L_sp[-2])[2];
hp[12] = getPTR(L_sp[-2])[3];
hp[13] = getPTR(L_sp[-1])[3];
hp[14] = makePTR(hp+5);
atom = makePTR(hp+9);
hp += 15;
L_POP(2);
L_PUSH(atom);
goto F_sumMapAccfz;
}
F_sumMapAccfz___0:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_727;
  goto GC_COLLECT;
}
  GC_RET_727:
hp[0] = makeHDR(4);
hp[1] = makeFUN(&&F_valid);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = getPTR(L_sp[-1])[3];
hp[4] = getPTR(L_sp[-1])[4];
atom = makePTR(hp+0);
hp += 5;
eval_ret_addr = &&LABEL_728;
goto EVAL;
LABEL_728:
switch (res) {
case C_True:
L_POP(2);
L_PUSH(makeINT(1));
res = 1;
goto EVAL_RET;
case C_False:
L_POP(2);
L_PUSH(makeINT(0));
res = 0;
goto EVAL_RET;
}
F_fz:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_729;
  goto GC_COLLECT;
}
  GC_RET_729:
hp[0] = makeHDR(4);
hp[1] = makeFUN(&&F_valid);
hp[2] = getPTR(L_sp[-1])[2];
hp[3] = getPTR(L_sp[-1])[3];
hp[4] = getPTR(L_sp[-1])[4];
atom = makePTR(hp+0);
hp += 5;
eval_ret_addr = &&LABEL_730;
goto EVAL;
LABEL_730:
switch (res) {
case C_True:
L_POP(2);
L_PUSH(makeINT(1));
res = 1;
goto EVAL_RET;
case C_False:
L_POP(2);
L_PUSH(makeINT(0));
res = 0;
goto EVAL_RET;
}
F_length:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_731;
  goto GC_COLLECT;
}
  GC_RET_731:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&F_lengthAcc);
hp[2] = makeINT(0);
hp[3] = getPTR(L_sp[-1])[2];
atom = makePTR(hp+0);
hp += 4;
L_POP(1);
L_PUSH(atom);
goto F_lengthAcc;
F_lengthAcc:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_732;
  goto GC_COLLECT;
}
  GC_RET_732:
atom = getPTR(L_sp[-1])[3];
getPTR(L_sp[-1])[3] = makeINT(0);
eval_ret_addr = &&LABEL_733;
goto EVAL;
LABEL_733:
switch (res) {
case C_Nil:
atom = getPTR(L_sp[-2])[2];
L_POP(2);
goto TAIL_EVAL;
goto EVAL_RET;
case C_Cons:
hp[0] = makeHDR(3);
hp[1] = makeFUN(&&P_ADD);
hp[2] = getPTR(L_sp[-2])[2];
hp[3] = makeINT(1);
hp[4] = makeHDR(3);
hp[5] = makeFUN(&&F_lengthAcc);
hp[6] = makePTR(hp+0);
hp[7] = getPTR(L_sp[-1])[3];
atom = makePTR(hp+4);
hp += 8;
L_POP(2);
L_PUSH(atom);
goto F_lengthAcc;
}
P_ADD:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_735;
  goto GC_COLLECT;
}
  GC_RET_735:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_736;
goto EVAL;
LABEL_736:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_737;
goto EVAL;
LABEL_737:
L_POP(1);
res = getINT(L_top) + res;
L_POP(2);
L_PUSH(makeINT(res));
goto EVAL_RET;
P_SUB:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_738;
  goto GC_COLLECT;
}
  GC_RET_738:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_739;
goto EVAL;
LABEL_739:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_740;
goto EVAL;
LABEL_740:
L_POP(1);
res = getINT(L_top) - res;
L_POP(2);
L_PUSH(makeINT(res));
goto EVAL_RET;
P_EQ:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_741;
  goto GC_COLLECT;
}
  GC_RET_741:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_742;
goto EVAL;
LABEL_742:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_743;
goto EVAL;
LABEL_743:
L_POP(1);
res = getINT(L_top) == res ? C_True : C_False;
L_POP(2);
L_PUSH(makeCTR(res));
goto EVAL_RET;
P_NEQ:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_744;
  goto GC_COLLECT;
}
  GC_RET_744:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_745;
goto EVAL;
LABEL_745:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_746;
goto EVAL;
LABEL_746:
L_POP(1);
res = getINT(L_top) != res ? C_True : C_False;
L_POP(2);
L_PUSH(makeCTR(res));
goto EVAL_RET;
P_LEQ:
if (hp > heapEnd) {
  gc_ret = &&GC_RET_747;
  goto GC_COLLECT;
}
  GC_RET_747:
atom = getPTR(L_sp[-1])[2];
eval_ret_addr = &&LABEL_748;
goto EVAL;
LABEL_748:
atom = getPTR(L_sp[-2])[3];
eval_ret_addr = &&LABEL_749;
goto EVAL;
LABEL_749:
L_POP(1);
res = getINT(L_top) <= res ? C_True : C_False;
L_POP(2);
L_PUSH(makeCTR(res));
goto EVAL_RET;
GC_COPY:
if (from[0] == VISITED) {
  atom = from[1];
  goto *gc_copy_ret;
}
if (isPTR(from[1])) { from = getPTR(from[1]); goto GC_COPY; }
if (size(from[0]) == 1) { atom = from[1]; }
else {
  n = size(from[0]) + 1;
  //printf("Copy (%i);\n", n-1);
  atom = makePTR(free);
  for (i = 0; i < n; i++)
    { *free = from[i]; free++; }
  from[0] = VISITED;
  from[1] = atom;
}
goto *gc_copy_ret;
GC_COLLECT:
//printf("GC invoked (%i);\n", hp - fromSpace);
scan = toSpace;
free = toSpace;
for (p = L_base; p < L_sp; p++) {
  if (isPTR(*p)) {
    from = getPTR(*p);
    gc_copy_ret = &&GC_COPY_RET1; goto GC_COPY; GC_COPY_RET1:
    *p = atom;
  }
}
while (scan < free) {
  m = size(*scan); scan++;
  //printf("Scan (%i);\n", m);
  for (j = 0; j < m; j++) {
    if (isPTR(*scan)) {
      from = getPTR(*scan);
      gc_copy_ret = &&GC_COPY_RET2; goto GC_COPY; GC_COPY_RET2:
      *scan = atom;
    }
    scan++;
  }
}
for (frame = R_base; frame > R_sp; frame--) {
  p = frame->current;
  frame->current = 0;
  while (p && p[0] != VISITED && isPTR(p[1])) p = getPTR(p[1]);
  if (p && p[0] == VISITED) {
    if (isPTR(p[1])) frame->current = getPTR(p[1]);
  }
}
hp = free;
p = fromSpace; fromSpace = toSpace; toSpace = p;
p = fromSpaceEnd; fromSpaceEnd = toSpaceEnd; toSpaceEnd = p;
heapEnd = fromSpaceEnd;
L_top = L_sp[-1];
R_top_returnAddress = R_sp[1].returnAddress;
R_top_current = R_sp[1].current;
//printf("GC finished (%i);\n", hp - fromSpace);
goto *gc_ret;
}



